/****************************************************************************
 *
 * Copy right:   2021-, Copyrigths of RLWL Ltd.
 * File name:    Signal.h
 * Description:  Global variable definition H file
 * History:      Rev3.0   2021-07-06
 *
 ****************************************************************************/
#include "commontypedef.h"
#include "cmsis_os2.h"
#include "AppConfig.h"
#include "osasys.h"
#include "queue.h"
#include "bsp_custom.h"
//declear the bool vars
extern volatile BOOL NB_Fota_update_flag;
extern BOOL canSNMsgLostFlag;
extern BOOL canSNMsgRxCmpltFlag;
extern BOOL canVINMsgRxCmpltFlag;

//extern declear the UINT8 vars

extern UINT8 TcpErrorcount;
extern UINT8 TCPWorkState;
extern UINT8 TcpSendLen;
extern UINT8 GpsFlag;
extern UINT8 PadInterrupt;
extern UINT8 Lockstatus;

//declear the UINT16 vars
extern UINT16 nbHwVersion;
extern UINT16 ErrorNum[5];

//declear the UINT32 vars
extern UINT32 nbSwVersion;
extern volatile UINT32 TimeCounter;

//declear other vars
extern osMutexId_t Error_Mutex;
extern QueueHandle_t GpsRecvHandle;
extern QueueHandle_t UartWriteCmdHandle;
extern QueueHandle_t CanRecvHandle;
extern AppConfigDataType AppNVMData;
extern AppDataBody AppDataInfo;
extern AppSocketConnectionContext socContext; //网络连接状态
extern process_app gProcess_app;

extern UINT32 COMInTable[133];
extern UINT8 canRxShortError[133];
extern UINT8 canRxLongError[133];
extern UINT8 canRxErrorCounter[133];
extern UINT8 canRxFlag[133];
extern UINT8 UDSService[2];                   //uds 服务
extern UINT8 UDSSubService[2];                // uds 子服务
extern UINT8 UDSSubServiceActionCode[2];      // uds 子服务状态
extern UINT8 GpsData[16];                     //GPS 数据缓存区
extern UINT16 updateDifferDataPackageCounter; //差分包升级计数器
extern BOOL downloadReady;
extern UINT8 UDSSwitch; //下线检测标志位
extern UINT8 BattWorkStateDelay;
//declear the UINT8 vars
extern UINT8 csq;
extern UINT8 bmsStatus;
extern UINT8 bmsErrClass;
extern UINT8 chrgConctStatus;
extern UINT8 highVolPwrDwnReq;
extern UINT8 chrgStatus;
extern UINT8 bmsErrNum;
extern UINT8 bmsLife;
extern UINT8 battSoc;
extern UINT8 maxCellTemp;
extern UINT8 minCellTemp;
extern UINT8 avgCellTemp;
extern UINT8 maxVolSubsysCode;
extern UINT8 minVolSubsysCode;
extern UINT8 maxTempSubsysCode;
extern UINT8 maxTempCellCode;
extern UINT8 minTempSubsysCode;
extern UINT8 minTempCellCode;
extern UINT8 numOfChrgableSubsys;
extern UINT8 lengthOfChrgableSysCode;
extern UINT8 chrgableSysCode;
extern UINT8 chrgableSubsysCode;
extern UINT8 numOfCellTemp;
extern UINT8 numOfBattErr;
extern UINT8 battCellTemp[CELL_TEMP_NUM];
extern UINT8 mainPosRlyStatus;
extern UINT8 preRlyStatus;
extern UINT8 mainNegRlyStatus;
extern UINT8 thrRlyStatus;
extern UINT8 ptc1RlyStatus;
extern UINT8 airCondRlyStatus;
extern UINT8 dcChrg1PosRlyStatus;
extern UINT8 dcChrg1NegRlyStatus;
extern UINT8 dcChrg2PosRlyStatus;
extern UINT8 dcChrg2NegRlyStatus;
extern UINT8 heatPosRlyStatus;
extern UINT8 heatNegRlyStatus;
extern UINT8 coolRlyStatus;
extern UINT8 ptc2RlyStatus;
extern UINT8 mainPosRlyErrStatus;
extern UINT8 preRlyErrStatus;
extern UINT8 mainNegRlyErrStatus;
extern UINT8 thrRlyErrStatus;
extern UINT8 ptc1RlyErrStatus;
extern UINT8 airCondRlyErrStatus;
extern UINT8 dcChrg1PosRlyErrStatus;
extern UINT8 dcChrg1NegRlyErrStatus;
extern UINT8 dcChrg2PosRlyErrStatus;
extern UINT8 dcChrg2NegRlyErrStatus;
extern UINT8 heatPosRlyErrStatus;
extern UINT8 heatNegRlyErrStatus;
extern UINT8 coolRlyErrStatus;
extern UINT8 ptc2RlyErrStatus;
extern UINT8 battSOH;
extern UINT8 SN[24];
extern UINT8 bmsHVOn;
extern UINT8 acRelayStatus;
extern UINT8 ptcRelayStatus;
extern UINT8 mainRelayStatus;
extern UINT8 preRelayStatus;
extern UINT8 ptc2RelayStatus;
extern UINT8 acRelayErrorStatus;
extern UINT8 ptcRelayErrorStatus;
extern UINT8 mainRelayErrorStatus;
extern UINT8 preRelayErrorStatus;
extern UINT8 hvLockErrorStatus;
extern UINT8 ptc2RelayErrorStatus;
extern UINT8 ebcStatus;
extern UINT8 ebcAskHVOn;
extern UINT8 ebcAskHVOff;
extern UINT8 retainLockSignal;
extern UINT8 dischargeLockSignal;
extern UINT8 chargeLockSignal;
extern UINT8 errorClass;
extern UINT8 errorCode1;
extern UINT8 errorCode2;
extern UINT8 chargeFlag;
extern UINT8 exchangeBattAirPressure;
extern UINT8 lifeSignal;
extern UINT8 vehicleStatus;
extern UINT8 currentGearPosition;
extern UINT8 parkingBreakStatus;
extern UINT8 breakingStatus;
extern UINT8 VIN[17];
extern UINT8 frontBreakingPressure;
extern UINT8 backBreakingPressure;
extern UINT8 frontBreakingPressureErrorStatus;
extern UINT8 backBreakingPressureErrorStatus;
extern UINT8 dcdcErrorClass;
extern UINT8 dcdcWorkStatus;
extern UINT8 mainElectricityErrorClass;
extern UINT8 pumpWorkStatus;
extern UINT8 elecAirCompressorErrorStatus;
extern UINT8 elecAirCompressorWrokStatus;

//declear the UINT16 vars
extern UINT16 maxChrgCurrAllowed;
extern UINT16 maxDischrgCurrAllowed;
extern UINT16 packTotalVol;
extern UINT16 packTotalCurr;
extern UINT16 insulationR;
extern UINT16 maxCellVol;
extern UINT16 minCellVol;
extern UINT16 maxVolCellCode;
extern UINT16 minVoCelllCode;
extern UINT16 numOfCells;
extern UINT16 battCellU[CELL_NUM];
extern UINT16 vcuDCVol;

//declear the UINT32 vars
extern UINT32 accChrgAh;
extern UINT32 accDischrgAh;
extern UINT32 accChrgkWh;
extern UINT32 accDischrgkWh;
extern UINT32 accRecvryChrgAh;
extern UINT32 accRecvryChrgkWh;
extern UINT32 accStationChrgAh;
extern UINT32 accStationChrgkWh;
extern UINT32 accGunChrgAh;
extern UINT32 accGunChrgkWh;
extern UINT32 sglChrgAh;
extern UINT32 sglChrgkWh;
extern UINT32 ODO;
