/*
 * @Author       : ChenJie
 * @Date         : 2021-11-09 12:08:17
 * @Version      : V3.0
 * @LastEditors  : ChenJie
 * @LastEditTime : 2021-11-23 19:08:15
 * @Description  : file content
 * @FilePath     : \PLAT\project\ec616_0h00\apps\qx_app\src\AppFunc.c
 */
#include "AppFunc.h"
#include "numeric.h"
#include "hal_module_adapter.h"
/**
 * @brief : 初始化
 * @param {*}
 * @return {*}
 */
void canRxMsgSetInitValue(void)
{
	bmsStatus = 0xFF;
	bmsErrClass = 0xFF;
	chrgConctStatus = 0xFF;
	highVolPwrDwnReq = 0xFF;
	chrgStatus = 0xFF;
	bmsErrNum = 0xFF;
	bmsLife = 0xFF;
	maxChrgCurrAllowed = 0xFFFF;
	maxDischrgCurrAllowed = 0xFFFF;
	battSoc = 0xFF;
	packTotalVol = 0xFFFF;
	packTotalCurr = 0xFFFF;
	insulationR = 0xFFFF;
	maxCellVol = 0xFFFF;
	minCellVol = 0xFFFF;
	maxCellTemp = 0xFF;
	minCellTemp = 0xFF;
	avgCellTemp = 0xFF;
	maxVolSubsysCode = 0xFF;
	maxVolCellCode = 0xFFFF;
	minVolSubsysCode = 0xFF;
	minVoCelllCode = 0xFFFF;
	maxTempSubsysCode = 0xFF;
	maxTempCellCode = 0xFF;
	minTempSubsysCode = 0xFF;
	minTempCellCode = 0xFF;
	numOfChrgableSubsys = 0xFF;
	lengthOfChrgableSysCode = 0xFF;
	chrgableSysCode = 0xFF;
	chrgableSubsysCode = 0xFF;
	//numOfCells =0xFFFF;
	//numOfCellTemp =0xFF;
	numOfBattErr = 0xFF;
	for (UINT16 i = 0; i < CELL_NUM; i++)
	{
		battCellU[i] = 0xFFFF;
	}
	for (UINT8 i = 0; i < CELL_TEMP_NUM; i++)
	{
		battCellTemp[i] = 0xFF;
	}
	mainPosRlyStatus = 0xFF;
	preRlyStatus = 0xFF;
	mainNegRlyStatus = 0xFF;
	thrRlyStatus = 0xFF;
	ptc1RlyStatus = 0xFF;
	airCondRlyStatus = 0xFF;
	dcChrg1PosRlyStatus = 0xFF;
	dcChrg1NegRlyStatus = 0xFF;
	dcChrg2PosRlyStatus = 0xFF;
	dcChrg2NegRlyStatus = 0xFF;
	heatPosRlyStatus = 0xFF;
	heatNegRlyStatus = 0xFF;
	coolRlyStatus = 0xFF;
	ptc2RlyStatus = 0xFF;
	mainPosRlyErrStatus = 0xFF;
	preRlyErrStatus = 0xFF;
	mainNegRlyErrStatus = 0xFF;
	thrRlyErrStatus = 0xFF;
	ptc1RlyErrStatus = 0xFF;
	airCondRlyErrStatus = 0xFF;
	dcChrg1PosRlyErrStatus = 0xFF;
	dcChrg1NegRlyErrStatus = 0xFF;
	dcChrg2PosRlyErrStatus = 0xFF;
	dcChrg2NegRlyErrStatus = 0xFF;
	heatPosRlyErrStatus = 0xFF;
	heatNegRlyErrStatus = 0xFF;
	coolRlyErrStatus = 0xFF;
	ptc2RlyErrStatus = 0xFF;
	accChrgAh = 0xFFFFFFFF;
	accDischrgAh = 0xFFFFFFFF;
	accChrgkWh = 0xFFFFFFFF;
	accDischrgkWh = 0xFFFFFFFF;
	battSOH = 0xFF;
	for (UINT8 i = 0; i < 24; i++)
	{
		SN[i] = 0xFF;
	}
	accRecvryChrgAh = 0xFFFFFFFF;
	accRecvryChrgkWh = 0xFFFFFFFF;
	accStationChrgAh = 0xFFFFFFFF;
	accStationChrgkWh = 0xFFFFFFFF;
	accGunChrgAh = 0xFFFFFFFF;
	accGunChrgkWh = 0xFFFFFFFF;
	sglChrgAh = 0xFFFFFFFF;
	sglChrgkWh = 0xFFFFFFFF;
	bmsHVOn = 0xFF;
	vcuDCVol = 0xFFFF;
	acRelayStatus = 0xFF;
	ptcRelayStatus = 0xFF;
	mainRelayStatus = 0xFF;
	preRelayStatus = 0xFF;
	ptc2RelayStatus = 0xFF;
	acRelayErrorStatus = 0xFF;
	ptcRelayErrorStatus = 0xFF;
	mainRelayErrorStatus = 0xFF;
	preRelayErrorStatus = 0xFF;
	hvLockErrorStatus = 0xFF;
	ptc2RelayErrorStatus = 0xFF;
	ebcStatus = 0xFF;
	ebcAskHVOn = 0xFF;
	ebcAskHVOff = 0xFF;
	retainLockSignal = 0xFF;
	dischargeLockSignal = 0xFF;
	chargeLockSignal = 0xFF;
	errorClass = 0xFF;
	errorCode1 = 0xFF;
	errorCode2 = 0xFF;
	chargeFlag = 0xFF;
	exchangeBattAirPressure = 0xFF;
	lifeSignal = 0xFF;
	vehicleStatus = 0xFF;
	currentGearPosition = 0xFF;
	parkingBreakStatus = 0xFF;
	breakingStatus = 0xFF;
	for (UINT8 i = 0; i < sizeof(VIN); i++)
	{
		VIN[i] = 0xFF;
	}
	frontBreakingPressure = 0xFF;
	backBreakingPressure = 0xFF;
	frontBreakingPressureErrorStatus = 0xFF;
	backBreakingPressureErrorStatus = 0xFF;
	ODO = 0xFFFFFFFF;
	dcdcErrorClass = 0xFF;
	dcdcWorkStatus = 0xFF;
	mainElectricityErrorClass = 0xFF;
	pumpWorkStatus = 0xFF;
	elecAirCompressorErrorStatus = 0xFF;
	elecAirCompressorWrokStatus = 0xFF;
}
UINT8 bcc_chk(UINT8 *data, UINT16 length)
{
	UINT8 bcc_chk_return = 0x00;
	UINT16 count = 0;
	while (count < length)
	{
		bcc_chk_return ^= data[count];
		count++;
	}
	return bcc_chk_return;
}
/***********************************************************************************************************************
 * LED控制函数
 * 输入：运行状�?
 * 输出：LED控制
 * 处理：根据不同状态进行LED显示
***********************************************************************************************************************/
void LEDDisplay(void)
{
	static UINT8 currentState = 0;
	static UINT8 LightTimer = 0;
	static UINT8 ErrorLightTimer = 0;

	UINT8 LEDFlashPeriod = 10; //1000ms
	float DutyRatio = 0.4;
	float socAccuracy = 0.4;
	LightTimer++;
	ErrorLightTimer++;
#ifdef USING_PRINTF1
	printf("[%d]-%d-%d-%d\n", __LINE__, LightTimer, ErrorLightTimer, battSoc);
#endif
	if (AppDataInfo.BattLock == TRUE || battSoc > 100 / socAccuracy) //电池整处于锁定状�?
	{
		if (LightTimer < (UINT8)(LEDFlashPeriod * DutyRatio))
		{
			NetSocDisplay(LED_SOC_0, LED_TURN_ON);
			NetSocDisplay(LED_SOC_1, LED_TURN_ON);
			NetSocDisplay(LED_SOC_2, LED_TURN_ON);
			NetSocDisplay(LED_SOC_3, LED_TURN_ON);
			FaultDisplay(LED_TURN_ON);
		}
		else if (LightTimer >= (UINT8)(LEDFlashPeriod * DutyRatio) && LightTimer < LEDFlashPeriod)
		{
			NetSocDisplay(LED_SOC_0, LED_TURN_OFF);
			NetSocDisplay(LED_SOC_1, LED_TURN_OFF);
			NetSocDisplay(LED_SOC_2, LED_TURN_OFF);
			NetSocDisplay(LED_SOC_3, LED_TURN_OFF);
			FaultDisplay(LED_TURN_OFF);
		}
		else
		{
			NetSocDisplay(LED_SOC_0, LED_TURN_OFF);
			NetSocDisplay(LED_SOC_1, LED_TURN_OFF);
			NetSocDisplay(LED_SOC_2, LED_TURN_OFF);
			NetSocDisplay(LED_SOC_3, LED_TURN_OFF);
			FaultDisplay(LED_TURN_OFF);
			LightTimer = 0;
		}
		return;
	}
	else //电池未处于锁定状�?
	{
		if (currentState != AppDataInfo.BattLock)
		{
			currentState = AppDataInfo.BattLock;
			LightTimer = 0;
		}
		if (battSoc <= 10 / socAccuracy)
		{
			if (LightTimer < (UINT8)(LEDFlashPeriod * DutyRatio))
			{
				NetSocDisplay(LED_SOC_0, LED_TURN_ON);
				NetSocDisplay(LED_SOC_1, LED_TURN_OFF);
				NetSocDisplay(LED_SOC_2, LED_TURN_OFF);
				NetSocDisplay(LED_SOC_3, LED_TURN_OFF);
				FaultDisplay(LED_TURN_OFF);
			}
			else if (LightTimer >= (UINT8)(LEDFlashPeriod * DutyRatio) && LightTimer < LEDFlashPeriod)
			{
				NetSocDisplay(LED_SOC_0, LED_TURN_OFF);
				NetSocDisplay(LED_SOC_1, LED_TURN_OFF);
				NetSocDisplay(LED_SOC_2, LED_TURN_OFF);
				NetSocDisplay(LED_SOC_3, LED_TURN_OFF);
				FaultDisplay(LED_TURN_OFF);
			}
			else
			{
				NetSocDisplay(LED_SOC_0, LED_TURN_OFF);
				NetSocDisplay(LED_SOC_1, LED_TURN_OFF);
				NetSocDisplay(LED_SOC_2, LED_TURN_OFF);
				NetSocDisplay(LED_SOC_3, LED_TURN_OFF);
				FaultDisplay(LED_TURN_OFF);
				LightTimer = 0;
			}
		}
		else if (battSoc > 10 / socAccuracy && battSoc <= 25 / socAccuracy)
		{
			NetSocDisplay(LED_SOC_0, LED_TURN_ON);
			NetSocDisplay(LED_SOC_1, LED_TURN_OFF);
			NetSocDisplay(LED_SOC_2, LED_TURN_OFF);
			NetSocDisplay(LED_SOC_3, LED_TURN_OFF);
			FaultDisplay(LED_TURN_OFF);
			LightTimer = 0;
		}
		else if (battSoc > 25 / socAccuracy && battSoc <= 50 / socAccuracy)
		{
			NetSocDisplay(LED_SOC_0, LED_TURN_ON);
			NetSocDisplay(LED_SOC_1, LED_TURN_ON);
			NetSocDisplay(LED_SOC_2, LED_TURN_OFF);
			NetSocDisplay(LED_SOC_3, LED_TURN_OFF);
			FaultDisplay(LED_TURN_OFF);
			LightTimer = 0;
		}
		else if (battSoc > 50 / socAccuracy && battSoc <= 75 / socAccuracy)
		{
			NetSocDisplay(LED_SOC_0, LED_TURN_ON);
			NetSocDisplay(LED_SOC_1, LED_TURN_ON);
			NetSocDisplay(LED_SOC_2, LED_TURN_ON);
			NetSocDisplay(LED_SOC_3, LED_TURN_OFF);
			FaultDisplay(LED_TURN_OFF);
			LightTimer = 0;
		}
		else if (battSoc > 75 / socAccuracy && battSoc <= 100 / socAccuracy)
		{
			NetSocDisplay(LED_SOC_0, LED_TURN_ON);
			NetSocDisplay(LED_SOC_1, LED_TURN_ON);
			NetSocDisplay(LED_SOC_2, LED_TURN_ON);
			NetSocDisplay(LED_SOC_3, LED_TURN_ON);
			FaultDisplay(LED_TURN_OFF);
			LightTimer = 0;
		}
	}
}

/***********************************************************************************************************************
 * BMS故障解码函数
 * 输入：BMS故障编码
 * 输出：状态参�?
 * 处理：将BMS故障编码依次解为标准故障�?
***********************************************************************************************************************/
static UINT8 BmsErrorDecode(UINT32 battWarningState)
{
	UINT16 ErrorNumTemp;
	UINT8 ret;
	if (battWarningState == 0)
	{
		return 0;
	}
	else
	{
		if (osOK == osMutexAcquire(Error_Mutex, 100))
		{
			ret = ((battWarningState)&0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 7;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在电芯过放告警故障！！\n";单体电压过低
			}

			ret = ((battWarningState >> 1) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 10;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在总电压过放告警故障！！\n";总电压过�?
			}

			ret = ((battWarningState >> 2) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 8;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在电芯过压告警故障！！\n";
			}

			ret = ((battWarningState >> 3) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 11;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在总电压过压告警故障！！\n";
			}

			ret = ((battWarningState >> 4) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 12;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在放电过流告警故障！！\n";
			}

			ret = ((battWarningState >> 5) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 13;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在充电过流告警故障！！\n";
			}

			ret = ((battWarningState >> 6) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 2;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在放电过温告警故障！！\n";
			}

			ret = ((battWarningState >> 7) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 2;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在充电过温告警故障！！\n";
			}

			ret = ((battWarningState >> 8) & 0x01) == 1;
			if (ret)
			{
				//str += "ERROR：存在环境高温告警故障！！\n";
			}

			ret = ((battWarningState >> 9) & 0x01) == 1;
			if (ret)
			{
				//str += "ERROR：存在环境低温告警故障！！\n";
			}

			ret = ((battWarningState >> 10) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 27;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在battSoc低告警故障！！\n";
			}

			ret = ((battWarningState >> 11) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 3;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在MOS高温告警故障！！\n";
			}

			ret = ((battWarningState >> 16) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 18;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在温度采集失�?传感器故障！！\n";
			}

			ret = ((battWarningState >> 17) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 19;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在电压采集失�?断线故障！！\n";
			}

			ret = ((battWarningState >> 18) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 17;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在放电MOS失效故障！！\n";
			}

			ret = ((battWarningState >> 19) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 16;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在充电MOS失效故障！！\n";
			}

			ret = ((battWarningState >> 20) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 22;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在电芯不均衡告警！！\n";
			}

			ret = ((battWarningState >> 22) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 1;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在放电低温告警故障！！\n";
			}

			ret = ((battWarningState >> 23) & 0x01) == 1;
			if (ret)
			{
				ErrorNumTemp = 1;
				PutErrorNum((UINT16 *)ErrorNum, sizeof(ErrorNum), ErrorNumTemp);
				//str += "ERROR：存在充电低温告警故障！！\n";
			}
		}
		else
		{
#ifdef USING_PRINTF
			printf("get Muxtex error\n");
#endif
		}
		osMutexRelease(Error_Mutex);
	}
	return 1;
}
/***********************************************************************************************************************
 * 获取故障码函�?
 * 输入：故障数组和长度
 * 输出：故障代�?
 * 处理：从故障数组中获取故障码，并将之前的故障码向前移�?
***********************************************************************************************************************/
UINT16 GetErrorNum(UINT16 *ErrorArray, UINT8 Errorlen)
{
	UINT16 OutNum;
	OutNum = *(ErrorArray);
	for (UINT8 i = 0; i < Errorlen - 1; i++)
	{
		*(ErrorArray + i) = *(ErrorArray + i + 1);
		if (*(ErrorArray + i + 1) == 0)
			break;
	}
	return OutNum;
}
/***********************************************************************************************************************
 * 故障码注入函�?
 * 输入：故障数组，故障长度，故障码
 * 输出：状�?
 * 处理：将故障码写入到故障数组中，如果存在则不写入，如果存在则不写�?
***********************************************************************************************************************/
UINT8 PutErrorNum(UINT16 *ErrorArray, UINT8 Errorlen, UINT16 ErrorNum)
{
	for (UINT8 i = 0; i < Errorlen; i++)
	{
		if (*(ErrorArray + i) == 0)
		{
			*(ErrorArray + i) = ErrorNum;
			return 0;
		}
		else
		{
			if (*(ErrorArray + i) == ErrorNum)
			{
				return 1;
			}
			else
			{
				continue;
			}
		}
	}
	return 2;
}
/***********************************************************************************************************************
 * 运行数据保存函数
 * 输入：空
 * 输出：空
 * 处理：将运行数据进行保存
***********************************************************************************************************************/
void SaveAppData(void)
{
	OSAFILE fp = PNULL;
	UINT32 writeCount = 0;
	AppDataHeader AppDataHr;
	fp = OsaFopen(APP_DATAINFO_FILE_NAME, "wb"); //read & write
	if (OsaFseek(fp, 0, SEEK_SET) != 0)
	{
#ifdef USING_PRINTF
		printf("Seek file failed [%d] \r\n", __LINE__);
#endif
		OsaFclose(fp);
		return;
	}
	if (fp == PNULL)
	{
#ifdef USING_PRINTF
		printf(" NVM, can't open/create NVM: 'qxappconfig.nvm', save NVM failed\n");
#endif
		return;
	}
	AppDataHr.fileBodySize = sizeof(AppDataInfo);
	AppDataHr.checkSum = OsaCalcCrcValue((UINT8 *)&AppDataInfo, sizeof(AppDataInfo));
	writeCount = OsaFwrite(&AppDataHr, sizeof(AppDataHr), 1, fp);
	if (writeCount != 1)
	{
#ifdef USING_PRINTF
		printf(" NVM: 'qxappconfig.nvm', write the file header failed\n");
#endif
		OsaFclose(fp);
		return;
	}
	AppDataInfo.appDataModify = FALSE;
	writeCount = OsaFwrite(&AppDataInfo, sizeof(AppDataInfo), 1, fp);
	if (writeCount != 1)
	{
#ifdef USING_PRINTF
		printf(" NVM: 'qxappconfig.nvm', write the file body failed\n");
#endif
	}
	OsaFclose(fp);
	return;
}
/***********************************************************************************************************************
 * 运行数据加载函数
 * 输入：空
 * 输出：空
 * 处理：将运行数据进行加载，若新增了数据项，则保持前面数据项不�?
***********************************************************************************************************************/
void LoadAppData(void)
{
	OSAFILE fp = PNULL;
	UINT32 readCount = 0;
	UINT8 crcCheck = 0;
	void *pReadAppConfig = (void *)&AppDataInfo;
	AppDataHeader AppDataHr;
	fp = OsaFopen(APP_DATAINFO_FILE_NAME, "rb"); //read only
	if (fp == PNULL)
	{
#ifdef USING_PRINTF
		printf(" NVM, can't open NVM: 'qxappData.nvm', use the defult value\n");
#endif
		setDefaultAppDataInfo();
		SaveAppData();
		return;
	}

	readCount = OsaFread(&AppDataHr, sizeof(AppDataHr), 1, fp);
	UINT8 readtimes = 0;
	while (readCount != 1 && readtimes <= 5)
	{
		readtimes++;
		readCount = OsaFread(&AppDataHr, sizeof(AppDataHr), 1, fp);
		osDelay(10);
	}
	if (readtimes > 5)
	{
		OsaFclose(fp);
		setDefaultAppDataInfo();
		SaveAppData();
		return;
	}
	if (AppDataHr.fileBodySize == sizeof(AppDataInfo)) //结构体数据没变动，可直接读出
	{
		readCount = OsaFread(pReadAppConfig, AppDataHr.fileBodySize, 1, fp);
		//crcCheck = OsaCalcCrcValue((UINT8 *)pReadAppConfig, sizeof(AppNVMData));
		readtimes = 0;
		while (readtimes <= 5 && readCount != 1)
		{
			readtimes++;
			readCount = OsaFread(pReadAppConfig, AppDataHr.fileBodySize, 1, fp);
			//crcCheck = OsaCalcCrcValue((UINT8 *)pReadAppConfig, sizeof(AppNVMData));
		}
	}
	else
	{
		setDefaultAppDataInfo();
		readCount = OsaFread(pReadAppConfig, AppDataHr.fileBodySize, 1, fp);
		//crcCheck = OsaCalcCrcValue((UINT8 *)pReadAppConfig, sizeof(AppNVMData));
		readtimes = 0;
		while (readtimes <= 5 && readCount != 1)
		{
			readtimes++;
			readCount = OsaFread(pReadAppConfig, AppDataHr.fileBodySize, 1, fp);
			//crcCheck = OsaCalcCrcValue((UINT8 *)pReadAppConfig, sizeof(AppNVMData));
		}
		SaveAppData();
#ifdef USING_PRINTF
		printf(" Struct update\n");
#endif
	}
	OsaFclose(fp);
	return;
}
/***********************************************************************************************************************
 * 配置文件保存函数
 * 输入：空
 * 输出：空
 * 处理：将全局配置文件进行保存
***********************************************************************************************************************/
void SaveAppConfig(void)
{
	OSAFILE fp = PNULL;
	UINT32 writeCount = 0;
	AppConfigDataHeader AppConfigHr; //4 bytes
	/*
     * open the NVM file
    */
	fp = OsaFopen(APP_CONFIG_FILE_NAME, "wb"); //read & write
	if (OsaFseek(fp, 0, SEEK_SET) != 0)
	{
#ifdef USING_PRINTF
		printf("Seek file failed [%d] \r\n", __LINE__);
#endif
		OsaFclose(fp);
		return;
	}
	if (fp == PNULL)
	{
#ifdef USING_PRINTF
		printf(" NVM, can't open/create NVM: 'qxappconfig.nvm', save NVM failed\n");
#endif
		return;
	}
	/*
     * write the header
    */
	AppConfigHr.fileBodySize = sizeof(AppNVMData);
	AppConfigHr.checkSum = OsaCalcCrcValue((UINT8 *)&AppNVMData, sizeof(AppNVMData));
	writeCount = OsaFwrite(&AppConfigHr, sizeof(AppConfigHr), 1, fp);
	if (writeCount != 1)
	{
#ifdef USING_PRINTF
		printf(" NVM: 'qxappconfig.nvm', write the file header failed\n");
#endif
		OsaFclose(fp);
		return;
	}
	/*
     * write the file body
    */
	AppNVMData.appDataModify = FALSE;
	writeCount = OsaFwrite(&AppNVMData, sizeof(AppNVMData), 1, fp);
	if (writeCount != 1)
	{
#ifdef USING_PRINTF
		printf(" NVM: 'qxappconfig.nvm', write the file body failed\n");
#endif
	}
	OsaFclose(fp);
	return;
}
/***********************************************************************************************************************
 * 配置文件加载函数
 * 输入：空
 * 输出：空
 * 处理：将全局配置文件进行加载
***********************************************************************************************************************/
void LoadAppConfig(void)
{
	OSAFILE fp = PNULL;
	UINT32 readCount = 0;
	AppConfigDataHeader AppConfigHr;
	UINT8 crcCheck = 0;
	void *pReadAppConfig = (void *)&AppNVMData;
	/*
     * open the NVM file
    */
	fp = OsaFopen(APP_CONFIG_FILE_NAME, "rb"); //read only

	if (fp == PNULL)
	{
#ifdef USING_PRINTF
		printf(" NVM, can't open NVM: 'qxappConfig.nvm', use the defult value\n");
#endif
		setDefaultAppConfigData();
		SaveAppConfig();
		return;
	}
	/*
     * read the file header
    */
	readCount = OsaFread(&AppConfigHr, sizeof(AppConfigHr), 1, fp);
	UINT8 readtimes = 0;
	while (readCount != 1 && readtimes <= 5)
	{
#ifdef USING_PRINTF
		printf("NVM: 'qxappconfig.nvm', can't read header, return: %d, use the defult value \n");
#endif
		readtimes++;
		readCount = OsaFread(&AppConfigHr, sizeof(AppConfigHr), 1, fp);
		osDelay(10);
	}
	if (readtimes > 5)
	{
		OsaFclose(fp);
		setDefaultAppConfigData();
		SaveAppConfig();
		return;
	}
	if (AppConfigHr.fileBodySize != sizeof(AppNVMData)) //file version is the same, but NVM file size not right
	{
#ifdef USING_PRINTF
		printf("MW NVM: 'midwareconfig.nvm', file body size not right: (%u/%u), use the defult value",
			   AppConfigHr.fileBodySize, sizeof(AppNVMData));
#endif
		OsaFclose(fp);
		setDefaultAppConfigData();
		SaveAppConfig();
		return;
	}
	/*
     * read the file body
    */
	readCount = OsaFread(pReadAppConfig, AppConfigHr.fileBodySize, 1, fp);
	crcCheck = OsaCalcCrcValue((UINT8 *)pReadAppConfig, sizeof(AppNVMData));
	readtimes = 0;
	//while (readtimes<=5 && crcCheck != AppConfigHr.checkSum)
	while (readtimes <= 5 && readCount != 1 && crcCheck != AppConfigHr.checkSum)
	{
		readtimes++;
		readCount = OsaFread(pReadAppConfig, AppConfigHr.fileBodySize, 1, fp);
		crcCheck = OsaCalcCrcValue((UINT8 *)pReadAppConfig, sizeof(AppNVMData));
	}
	if (readtimes > 5)
	{
#ifdef USING_PRINTF
		printf(" NVM: 'qxappconfig.nvm', can't read body, or body not right, (%u/%u), use the defult value\n ",
			   crcCheck, AppConfigHr.checkSum);
#endif
		OsaFclose(fp);
		setDefaultAppConfigData();
		SaveAppConfig();
		return;
	}
	OsaFclose(fp);
	return;
}
/***********************************************************************************************************************
 * 配置文件初始化函�?
 * 输入：空
 * 输出：空
 * 处理：将全局配置文件进行初始�?
 * 注意：配置数据不增加数据项，若增加数据项，需要修改加载函�?
***********************************************************************************************************************/
static void setDefaultAppConfigData(void)
{
	UINT8 i = 0;
	memset(&AppNVMData, 0x00, sizeof(AppConfigDataType));
	AppNVMData.appDataModify = TRUE; //数据更改标志�?
	// char sn[BATT_SN_LEN];
	// appGetSNNumSync(sn);
	memcpy(AppNVMData.battSN, DEFAULT_SN, BATT_SN_LEN);
	AppNVMData.isBattLocked = 0;	  //0:not locked;	1:locked
	AppNVMData.chargEndWorkTime = 30; //
	AppNVMData.BattTempCount = 5;	  //电池温度个数
	AppNVMData.BattCellCount = 17;	  //电池电压串数
	AppNVMData.BmsHwVersion = 0;
	AppNVMData.BmsSwVersion = 0;
	AppNVMData.BLSwVersion = BLSWVERSION;
	AppNVMData.DrvSwVersion = DRVSWVERSION;
	AppNVMData.AppSwVersion = APPSWVERSION; //APP软件版本
	AppNVMData.EOLState = EOLSTATE;
	return;
}
/***********************************************************************************************************************
 * 运行数据初始化函�?
 * 输入：空
 * 输出：空
 * 处理：将运行数据进行初始�?
 * 注：每增加一项数据项，需要增加默认�?
***********************************************************************************************************************/
static void setDefaultAppDataInfo(void)
{
	memset(&AppDataInfo, 0x00, sizeof(AppDataInfo));
	AppDataInfo.appDataModify = false;
	AppDataInfo.BattInfoSendFreqHigh = 10;
	AppDataInfo.BattInfoSendFreqNomal = 30;
	AppDataInfo.BattInfoSendFreqLow = 60;
	AppDataInfo.PosInfoSendFreqHigh = 10;
	AppDataInfo.PosInfoSendFreqNormal = 30;
	AppDataInfo.PosInfoSendFreqLow = 60;
	AppDataInfo.AccMileage = 0;
	AppDataInfo.SysReStartCount = 0;
	AppDataInfo.RelayControl = 0;
	AppDataInfo.BattLock = 0;
	AppDataInfo.BattStolenFlag = 0;
	memset(AppDataInfo.blcv_Q_totalCpE, 0x00, 28);
	memset(AppDataInfo.blcv_Q_reqCpE, 0x00, 28);
	AppDataInfo.socd_pct_bcuSocE = 0;
	AppDataInfo.socd_pct_battSocE = 0;
	AppDataInfo.sohd_tm_chrgStartStatE = 0;
	AppDataInfo.sohd_flg_chrgEndE = 0;
	memset(AppDataInfo.sohv_V_chrgStartStatE, 0x00, 28);
	AppDataInfo.sohd_Q_chrgE = 0;
	memset(AppDataInfo.sohv_Q_packCapArrE, 300, 10);
	memset(AppDataInfo.VIN, 0xFF, 17);

	return;
}

/***********************************************************************************************************************
 * Fota升级处理函数
 * 输入：网络接收的数据，网络链接ID
 * 输出�?x00表示数据未准备完成，0x01表示数据模块OTA数据准备完成�?x88表示BMS的OTA数据准备完成
 * 处理：将接收的数据进行校验，搬运至升级区域，并进行应�?
***********************************************************************************************************************/
void Fota_Func(UINT8 *DataPtr, INT32 connectId)
{
	Fota_Type Fota_S;
	UINT8 Fota_Answer[43];
	UINT8 Fota_Cmd;
	INT8 ret;
	UINT8 *Data_Read_Buffer = PNULL;
	UINT8 Data_Read_Crc;
	if (*(DataPtr + 30) == 0x01)
	{
		Fota_S.Fota_Flash_Addres = FLASH_FOTA_REGION_START;
		Fota_Cmd = *(DataPtr + 31);
		Fota_Answer[0] = TCP_START_SYM1;
		Fota_Answer[1] = TCP_START_SYM2;
		Fota_Answer[2] = TCP_CONCMD_SYM;
		switch (Fota_Cmd)
		{
		case 0x01:
		{
			Fota_S.Fota_All_Data_Len = *(DataPtr + 33) << 24 | *(DataPtr + 34) << 16 | *(DataPtr + 35) << 8 | *(DataPtr + 36);
			Fota_S.Fota_Current_Addres = *(DataPtr + 37) << 24 | *(DataPtr + 38) << 16 | *(DataPtr + 39) << 8 | *(DataPtr + 40);
			if (Fota_S.Fota_All_Data_Len >= (FLASH_BMS_FOTA_START_ADDR - FLASH_FOTA_REGION_START))
			{
				Fota_Answer[3] = 0x02;
			}
			else
			{
				Fota_Answer[3] = 0x01;
				BSP_QSPI_Erase_Safe(Fota_S.Fota_Flash_Addres, (FLASH_BMS_FOTA_START_ADDR - FLASH_FOTA_REGION_START)); //512k-32k = 480k -> 0x75300  0x78000
			}
			memcpy(&Fota_Answer[4], (DataPtr + 4), BATT_SN_LEN);
			Fota_Answer[21] = TCP_ENCPT_DISABLE;
			Fota_Answer[22] = 0x00;
			Fota_Answer[23] = 0x12;
			memcpy(&Fota_Answer[24], (DataPtr + 24), 18);
			Fota_Answer[42] = bcc_chk_fota(Fota_Answer, 42);
			tcpipConnectionSend(connectId, Fota_Answer, 43, 0, 0, 0);
			break;
		}
		case 0x02:
		{
			Fota_S.Fota_All_Data_Len = *(DataPtr + 33) << 24 | *(DataPtr + 34) << 16 | *(DataPtr + 35) << 8 | *(DataPtr + 36);
			Fota_S.Fota_Current_Addres = *(DataPtr + 37) << 24 | *(DataPtr + 38) << 16 | *(DataPtr + 39) << 8 | *(DataPtr + 40);
			Fota_S.Fota_Recv_Data_Len = *(DataPtr + 41);
			memset(Fota_S.Fota_Recv_Data, 0x00, 100);
			memcpy(Fota_S.Fota_Recv_Data, (DataPtr + 42), *(DataPtr + 41));
			Fota_S.Fota_CRC = Fota_crc_chk(Fota_S.Fota_Recv_Data, Fota_S.Fota_Recv_Data_Len);
			Data_Read_Buffer = malloc(Fota_S.Fota_Recv_Data_Len + 1);
			if (Fota_S.Fota_CRC == *(DataPtr + Fota_S.Fota_Recv_Data_Len + 42) || Data_Read_Buffer != PNULL)
			{
				if (Fota_S.Fota_Recv_Data_Len % 4 != 0)
				{
					Fota_S.Fota_Recv_Data_Len = Fota_S.Fota_Recv_Data_Len + 4 - (Fota_S.Fota_Recv_Data_Len % 4);
				}
				BSP_QSPI_Write_Safe(Fota_S.Fota_Recv_Data, Fota_S.Fota_Flash_Addres + Fota_S.Fota_Current_Addres, Fota_S.Fota_Recv_Data_Len);
				memset(Data_Read_Buffer, 0x00, Fota_S.Fota_Recv_Data_Len);
				BSP_QSPI_Read_Safe(Data_Read_Buffer, Fota_S.Fota_Flash_Addres + Fota_S.Fota_Current_Addres, Fota_S.Fota_Recv_Data_Len);
				Data_Read_Crc = Fota_crc_chk(Data_Read_Buffer, Fota_S.Fota_Recv_Data_Len);
#ifdef USING_PRINTF1
				printf("Data_Read_Buffer:\n");
				for (int i = 0; i < Fota_S.Fota_Recv_Data_Len; i++)
				{
					printf("%x  ", *(Data_Read_Buffer + i));
				}
				printf("\n");
#endif
				if (Data_Read_Crc == Fota_S.Fota_CRC)
				{
					Fota_Answer[3] = 0x01;
				}
				else
				{
					Fota_Answer[3] = 0x02;
					BSP_QSPI_Erase_Safe(Fota_S.Fota_Flash_Addres + Fota_S.Fota_Current_Addres, Fota_S.Fota_Recv_Data_Len);
				}
			}
			else //数据校验失败
			{
				Fota_Answer[3] = 0x02;
			}
			if (Data_Read_Buffer != PNULL)
				free(Data_Read_Buffer);
			Data_Read_Buffer = PNULL;
			memcpy(&Fota_Answer[4], (DataPtr + 4), BATT_SN_LEN);
			Fota_Answer[21] = TCP_ENCPT_DISABLE;
			Fota_Answer[22] = 0x00;
			Fota_Answer[23] = 0x12;
			memcpy(&Fota_Answer[24], (DataPtr + 24), 18);
			Fota_Answer[42] = bcc_chk_fota(Fota_Answer, 42);
			tcpipConnectionSend(connectId, Fota_Answer, 43, 0, 0, 0);
			break;
		}
		case 0x03:
		{
			Fota_S.Fota_All_Data_Len = *(DataPtr + 33) << 24 | *(DataPtr + 34) << 16 | *(DataPtr + 35) << 8 | *(DataPtr + 36);
			Fota_S.Fota_Current_Addres = *(DataPtr + 37) << 24 | *(DataPtr + 38) << 16 | *(DataPtr + 39) << 8 | *(DataPtr + 40);
			Fota_Answer[3] = 0x01;
			memcpy(&Fota_Answer[4], (DataPtr + 4), BATT_SN_LEN);
			Fota_Answer[21] = TCP_ENCPT_DISABLE;
			Fota_Answer[22] = 0x00;
			Fota_Answer[23] = 0x12;
			memcpy(&Fota_Answer[24], (DataPtr + 24), 18);
			Fota_Answer[42] = bcc_chk_fota(Fota_Answer, 42);
			tcpipConnectionSend(connectId, Fota_Answer, 43, 0, 0, 0);
			if (Fota_S.Fota_All_Data_Len == Fota_S.Fota_Current_Addres)
			{
				NB_Fota_update_flag = TRUE;
			}
			else
			{
				NB_Fota_update_flag = FALSE;
			}
			break;
		}
		default:
		{
			Fota_Answer[3] = 0x02;
			memcpy(&Fota_Answer[4], (DataPtr + 4), BATT_SN_LEN);
			Fota_Answer[21] = TCP_ENCPT_DISABLE;
			Fota_Answer[22] = 0x00;
			Fota_Answer[23] = 0x12;
			memcpy(&Fota_Answer[24], (DataPtr + 24), 18);
			Fota_Answer[42] = bcc_chk_fota(Fota_Answer, 42);
			tcpipConnectionSend(connectId, Fota_Answer, 43, 0, 0, 0);
			break;
		}
		}
	}
	else if (*(DataPtr + 30) == 0x88) //BMS升级文件存放
	{
		Fota_S.Fota_Flash_Addres = FLASH_BMS_FOTA_START_ADDR;
		Fota_Cmd = *(DataPtr + 31);
		Fota_Answer[0] = TCP_START_SYM1;
		Fota_Answer[1] = TCP_START_SYM2;
		Fota_Answer[2] = TCP_CONCMD_SYM;
		switch (Fota_Cmd)
		{
		case 0x01:
		{
			Fota_S.Fota_All_Data_Len = *(DataPtr + 33) << 24 | *(DataPtr + 34) << 16 | *(DataPtr + 35) << 8 | *(DataPtr + 36);
			Fota_S.Fota_Current_Addres = *(DataPtr + 37) << 24 | *(DataPtr + 38) << 16 | *(DataPtr + 39) << 8 | *(DataPtr + 40);
			if (Fota_S.Fota_All_Data_Len >= (FLASH_BMS_FOTA_END_ADDR - FLASH_BMS_FOTA_START_ADDR))
			{
				Fota_Answer[3] = 0x02;
			}
			else
			{
				Fota_Answer[3] = 0x01;
			}
			memcpy(&Fota_Answer[4], (DataPtr + 4), BATT_SN_LEN);
			Fota_Answer[21] = TCP_ENCPT_DISABLE;
			Fota_Answer[22] = 0x00;
			Fota_Answer[23] = 0x12;
			memcpy(&Fota_Answer[24], (DataPtr + 24), 18);
			Fota_Answer[42] = bcc_chk_fota(Fota_Answer, 42);
			tcpipConnectionSend(connectId, Fota_Answer, 43, 0, 0, 0);
			if (Fota_Answer[3] == 0x01)
			{
				BSP_QSPI_Erase_Safe(Fota_S.Fota_Flash_Addres, (FLASH_BMS_FOTA_END_ADDR - FLASH_BMS_FOTA_START_ADDR)); //512k-32k = 480k -> 0x75300  0x78000
			}
			break;
		}
		case 0x02:
		{
			Fota_S.Fota_All_Data_Len = *(DataPtr + 33) << 24 | *(DataPtr + 34) << 16 | *(DataPtr + 35) << 8 | *(DataPtr + 36);
			Fota_S.Fota_Current_Addres = *(DataPtr + 37) << 24 | *(DataPtr + 38) << 16 | *(DataPtr + 39) << 8 | *(DataPtr + 40);
			Fota_S.Fota_Recv_Data_Len = *(DataPtr + 41);
			memset(Fota_S.Fota_Recv_Data, 0x00, 100);
			memcpy(Fota_S.Fota_Recv_Data, (DataPtr + 42), *(DataPtr + 41));
			Fota_S.Fota_CRC = Fota_crc_chk(Fota_S.Fota_Recv_Data, Fota_S.Fota_Recv_Data_Len);
			Data_Read_Buffer = malloc(Fota_S.Fota_Recv_Data_Len);
			if (Fota_S.Fota_CRC == *(DataPtr + Fota_S.Fota_Recv_Data_Len + 42) || Data_Read_Buffer != PNULL)
			{
				if (Fota_S.Fota_Recv_Data_Len % 4 != 0)
				{
					Fota_S.Fota_Recv_Data_Len = Fota_S.Fota_Recv_Data_Len + 4 - (Fota_S.Fota_Recv_Data_Len % 4);
				}
				BSP_QSPI_Write_Safe(Fota_S.Fota_Recv_Data, Fota_S.Fota_Flash_Addres + Fota_S.Fota_Current_Addres, Fota_S.Fota_Recv_Data_Len);

				BSP_QSPI_Read_Safe(Data_Read_Buffer, Fota_S.Fota_Flash_Addres + Fota_S.Fota_Current_Addres, Fota_S.Fota_Recv_Data_Len);
				Data_Read_Crc = Fota_crc_chk(Data_Read_Buffer, Fota_S.Fota_Recv_Data_Len);
#ifdef USING_PRINTF1
				printf("\n\n\n");
				UINT8 temp[1];
				for (int i = 0; i < Fota_S.Fota_Recv_Data_Len; i++)
				{
					printf("%x  ", *(Data_Read_Buffer + i));
				}
				printf("\n\n\n");
#endif
				if (Data_Read_Crc == Fota_S.Fota_CRC)
				{
					Fota_Answer[3] = 0x01;
				}
				else
				{
					Fota_Answer[3] = 0x02;
					BSP_QSPI_Erase_Safe(Fota_S.Fota_Flash_Addres + Fota_S.Fota_Current_Addres, Fota_S.Fota_Recv_Data_Len);
				}
			}
			else //数据校验失败
			{
				Fota_Answer[3] = 0x02;
			}
			if (Data_Read_Buffer != PNULL)
				free(Data_Read_Buffer);
			Data_Read_Buffer = PNULL;
			memcpy(&Fota_Answer[4], (DataPtr + 4), BATT_SN_LEN);
			Fota_Answer[21] = TCP_ENCPT_DISABLE;
			Fota_Answer[22] = 0x00;
			Fota_Answer[23] = 0x12;
			memcpy(&Fota_Answer[24], (DataPtr + 24), 18);
			Fota_Answer[42] = bcc_chk_fota(Fota_Answer, 42);
			tcpipConnectionSend(connectId, Fota_Answer, 43, 0, 0, 0);
			break;
		}
		case 0x03:
		{
			Fota_S.Fota_All_Data_Len = *(DataPtr + 33) << 24 | *(DataPtr + 34) << 16 | *(DataPtr + 35) << 8 | *(DataPtr + 36);
			Fota_S.Fota_Current_Addres = *(DataPtr + 37) << 24 | *(DataPtr + 38) << 16 | *(DataPtr + 39) << 8 | *(DataPtr + 40);
			Fota_Answer[3] = 0x01;
			memcpy(&Fota_Answer[4], (DataPtr + 4), BATT_SN_LEN);
			Fota_Answer[21] = TCP_ENCPT_DISABLE;
			Fota_Answer[22] = 0x00;
			Fota_Answer[23] = 0x12;
			memcpy(&Fota_Answer[24], (DataPtr + 24), 18);
			Fota_Answer[42] = bcc_chk_fota(Fota_Answer, 42);
			tcpipConnectionSend(connectId, Fota_Answer, 43, 0, 0, 0);
			if (Fota_S.Fota_All_Data_Len == Fota_S.Fota_Current_Addres)
			{
				//BMS_Fota_update_flag = TRUE;
			}
			else
			{
				//BMS_Fota_update_flag = FALSE;
			}
			break;
		}
		default:
		{
			Fota_Answer[3] = 0x02;
			memcpy(&Fota_Answer[4], (DataPtr + 4), BATT_SN_LEN);
			Fota_Answer[21] = TCP_ENCPT_DISABLE;
			Fota_Answer[22] = 0x00;
			Fota_Answer[23] = 0x12;
			memcpy(&Fota_Answer[24], (DataPtr + 24), 18);
			Fota_Answer[42] = bcc_chk_fota(Fota_Answer, 42);
			tcpipConnectionSend(connectId, Fota_Answer, 43, 0, 0, 0);
			break;
		}
		}
	}
}
static UINT8 bcc_chk_fota(UINT8 *data, UINT8 length)
{
	UINT8 bcc_chk_return = 0x00;
	UINT8 count = 0;
	while (count < length)
	{
		bcc_chk_return ^= data[count];
		count++;
	}
	return bcc_chk_return;
}
static UINT8 Fota_crc_chk(UINT8 *data, UINT8 length)
{
	UINT8 reg_crc = 0x00;
	while (length--)
	{
		reg_crc ^= *data++;
	}
	return reg_crc;
}

/***********************************************************************************************************************
 * 周期性报文拆�?
 * 输入：报文ID、can报文数据（指针）
 * 输出�?-
 * 处理：根据不同的ID，将数据进行拆包，并放置到相应的变量�?
***********************************************************************************************************************/
void DecodeFunction(UINT32 ID, UINT8 *rawData)
{
	static UINT8 snAndVinMsgFlag = 0;
	switch (ID)
	{
	case 0x18FF06F3:
		bmsStatus = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xF);
		bmsErrClass = (UINT8)(((*(UINT8 *)(rawData + 0)) >> 4) & 0xF);
		chrgConctStatus = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0x3);
		highVolPwrDwnReq = (UINT8)(((*(UINT8 *)(rawData + 1)) >> 2) & 0x3);
		chrgStatus = (UINT8)(((*(UINT8 *)(rawData + 1)) >> 4) & 0x7);
		bmsErrNum = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		bmsLife = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		canRxFlag[0] = 0x01;
		break;
	case 0x18FF07F3:
		maxChrgCurrAllowed = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		maxDischrgCurrAllowed = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		canRxFlag[1] = 0x01;
		break;
	case 0x18FF30F3:
		battSoc = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		packTotalVol = (UINT16)(((*(UINT16 *)(rawData + 1))) & 0xFFFF);
		packTotalCurr = (UINT16)(((*(UINT16 *)(rawData + 3))) & 0xFFFF);
		insulationR = (UINT16)(((*(UINT16 *)(rawData + 5))) & 0xFFFF);
		canRxFlag[2] = 0x01;
		break;
	case 0x18FF51F3:
		maxCellVol = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		minCellVol = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		maxCellTemp = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		minCellTemp = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		avgCellTemp = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		canRxFlag[3] = 0x01;
		break;
	case 0x18FF52F3:
		maxVolSubsysCode = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		maxVolCellCode = (UINT16)(((*(UINT16 *)(rawData + 1))) & 0xFFFF);
		minVolSubsysCode = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		minVoCelllCode = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		canRxFlag[4] = 0x01;
		break;
	case 0x18FF53F3:
		maxTempSubsysCode = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		maxTempCellCode = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		minTempSubsysCode = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		minTempCellCode = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		canRxFlag[5] = 0x01;
		break;
	case 0x18FF54F3:
		numOfChrgableSubsys = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		lengthOfChrgableSysCode = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		chrgableSysCode = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		chrgableSubsysCode = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		numOfCells = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		numOfCellTemp = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		numOfBattErr = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		canRxFlag[6] = 0x01;
		break;
	case 0x1801FBF3:
		battCellU[0] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[1] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[2] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[3] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[7] = 0x01;
		break;
	case 0x1802FBF3:
		battCellU[4] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[5] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[6] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[7] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[8] = 0x01;
		break;
	case 0x1803FBF3:
		battCellU[8] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[9] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[10] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[11] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[9] = 0x01;
		break;
	case 0x1804FBF3:
		battCellU[12] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[13] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[14] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[15] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[10] = 0x01;
		break;
	case 0x1805FBF3:
		battCellU[16] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[17] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[18] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[19] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[11] = 0x01;
		break;
	case 0x1806FBF3:
		battCellU[20] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[21] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[22] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[23] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[12] = 0x01;
		break;
	case 0x1807FBF3:
		battCellU[24] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[25] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[26] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[27] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[13] = 0x01;
		break;
	case 0x1808FBF3:
		battCellU[28] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[29] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[30] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[31] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[14] = 0x01;
		break;
	case 0x1809FBF3:
		battCellU[32] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[33] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[34] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[35] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[15] = 0x01;
		break;
	case 0x180AFBF3:
		battCellU[36] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[37] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[38] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[39] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[16] = 0x01;
		break;
	case 0x180BFBF3:
		battCellU[40] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[41] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[42] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[43] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[17] = 0x01;
		break;
	case 0x180CFBF3:
		battCellU[44] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[45] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[46] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[47] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[18] = 0x01;
		break;
	case 0x180DFBF3:
		battCellU[48] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[49] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[50] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[51] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[19] = 0x01;
		break;
	case 0x180EFBF3:
		battCellU[52] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[53] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[54] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[55] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[20] = 0x01;
		break;
	case 0x180FFBF3:
		battCellU[56] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[57] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[58] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[59] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[21] = 0x01;
		break;
	case 0x1810FBF3:
		battCellU[60] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[61] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[62] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[63] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[22] = 0x01;
		break;
	case 0x1811FBF3:
		battCellU[64] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[65] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[66] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[67] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[23] = 0x01;
		break;
	case 0x1812FBF3:
		battCellU[68] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[69] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[70] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[71] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[24] = 0x01;
		break;
	case 0x1813FBF3:
		battCellU[72] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[73] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[74] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[75] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[25] = 0x01;
		break;
	case 0x1814FBF3:
		battCellU[76] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[77] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[78] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[79] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[26] = 0x01;
		break;
	case 0x1815FBF3:
		battCellU[80] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[81] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[82] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[83] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[27] = 0x01;
		break;
	case 0x1816FBF3:
		battCellU[84] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[85] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[86] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[87] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[28] = 0x01;
		break;
	case 0x1817FBF3:
		battCellU[88] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[89] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[90] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[91] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[29] = 0x01;
		break;
	case 0x1818FBF3:
		battCellU[92] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[93] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[94] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[95] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[30] = 0x01;
		break;
	case 0x1819FBF3:
		battCellU[96] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[97] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[98] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[99] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[31] = 0x01;
		break;
	case 0x181AFBF3:
		battCellU[100] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[101] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[102] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[103] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[32] = 0x01;
		break;
	case 0x181BFBF3:
		battCellU[104] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[105] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[106] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[107] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[33] = 0x01;
		break;
	case 0x181CFBF3:
		battCellU[108] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[109] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[110] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[111] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[34] = 0x01;
		break;
	case 0x181DFBF3:
		battCellU[112] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[113] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[114] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[115] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[35] = 0x01;
		break;
	case 0x181EFBF3:
		battCellU[116] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[117] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[118] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[119] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[36] = 0x01;
		break;
	case 0x181FFBF3:
		battCellU[120] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[121] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[122] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[123] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[37] = 0x01;
		break;
	case 0x1820FBF3:
		battCellU[124] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[125] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[126] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[127] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[38] = 0x01;
		break;
	case 0x1821FBF3:
		battCellU[128] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[129] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[130] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[131] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[39] = 0x01;
		break;
	case 0x1822FBF3:
		battCellU[132] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[133] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[134] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[135] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[40] = 0x01;
		break;
	case 0x1823FBF3:
		battCellU[136] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[137] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[138] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[139] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[41] = 0x01;
		break;
	case 0x1824FBF3:
		battCellU[140] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[141] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[142] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[143] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[42] = 0x01;
		break;
	case 0x1825FBF3:
		battCellU[144] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[145] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[146] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[147] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[43] = 0x01;
		break;
	case 0x1826FBF3:
		battCellU[148] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[149] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[150] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[151] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[44] = 0x01;
		break;
	case 0x1827FBF3:
		battCellU[152] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[153] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[154] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[155] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[45] = 0x01;
		break;
	case 0x1828FBF3:
		battCellU[156] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[157] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[158] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[159] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[46] = 0x01;
		break;
	case 0x1829FBF3:
		battCellU[160] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[161] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[162] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[163] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[47] = 0x01;
		break;
	case 0x182AFBF3:
		battCellU[164] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[165] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[166] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[167] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[48] = 0x01;
		break;
	case 0x182BFBF3:
		battCellU[168] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[169] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[170] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[171] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[49] = 0x01;
		break;
	case 0x182CFBF3:
		battCellU[172] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[173] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[174] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[175] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[50] = 0x01;
		break;
	case 0x182DFBF3:
		battCellU[176] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[177] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[178] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[179] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[51] = 0x01;
		break;
	case 0x182EFBF3:
		battCellU[180] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[181] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[182] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[183] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[52] = 0x01;
		break;
	case 0x182FFBF3:
		battCellU[184] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[185] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[186] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[187] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[53] = 0x01;
		break;
	case 0x1830FBF3:
		battCellU[188] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[189] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[190] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[191] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[54] = 0x01;
		break;
	case 0x1831FBF3:
		battCellU[192] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[193] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[194] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[195] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[55] = 0x01;
		break;
	case 0x1832FBF3:
		battCellU[196] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[197] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[198] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[199] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[56] = 0x01;
		break;
	case 0x1833FBF3:
		battCellU[200] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[201] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[202] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[203] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[57] = 0x01;
		break;
	case 0x1834FBF3:
		battCellU[204] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[205] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[206] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[207] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[58] = 0x01;
		break;
	case 0x1835FBF3:
		battCellU[208] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[209] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[210] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[211] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[59] = 0x01;
		break;
	case 0x1836FBF3:
		battCellU[212] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[213] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[214] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[215] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[60] = 0x01;
		break;
	case 0x1837FBF3:
		battCellU[216] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[217] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[218] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[219] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[61] = 0x01;
		break;
	case 0x1838FBF3:
		battCellU[220] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[221] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[222] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[223] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[62] = 0x01;
		break;
	case 0x1839FBF3:
		battCellU[224] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[225] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[226] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[227] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[63] = 0x01;
		break;
	case 0x183AFBF3:
		battCellU[228] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[229] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[230] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[231] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[64] = 0x01;
		break;
	case 0x183BFBF3:
		battCellU[232] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[233] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[234] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[235] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[65] = 0x01;
		break;
	case 0x183CFBF3:
		battCellU[236] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[237] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[238] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[239] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[66] = 0x01;
		break;
	case 0x183DFBF3:
		battCellU[240] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[241] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[242] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[243] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[67] = 0x01;
		break;
	case 0x183EFBF3:
		battCellU[244] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[245] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[246] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[247] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[68] = 0x01;
		break;
	case 0x183FFBF3:
		battCellU[248] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[249] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[250] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[251] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[69] = 0x01;
		break;
	case 0x1840FBF3:
		battCellU[252] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[253] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[254] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[255] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[70] = 0x01;
		break;
	case 0x1841FBF3:
		battCellU[256] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[257] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[258] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[259] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[71] = 0x01;
		break;
	case 0x1842FBF3:
		battCellU[260] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[261] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[262] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[263] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[72] = 0x01;
		break;
	case 0x1843FBF3:
		battCellU[264] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[265] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[266] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[267] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[73] = 0x01;
		break;
	case 0x1844FBF3:
		battCellU[268] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[269] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[270] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[271] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[74] = 0x01;
		break;
	case 0x1845FBF3:
		battCellU[272] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[273] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[274] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[275] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[75] = 0x01;
		break;
	case 0x1846FBF3:
		battCellU[276] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[277] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[278] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[279] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[76] = 0x01;
		break;
	case 0x1847FBF3:
		battCellU[280] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[281] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[282] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[283] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[77] = 0x01;
		break;
	case 0x1848FBF3:
		battCellU[284] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[285] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[286] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[287] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[78] = 0x01;
		break;
	case 0x1849FBF3:
		battCellU[288] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[289] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[290] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[291] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[79] = 0x01;
		break;
	case 0x184AFBF3:
		battCellU[292] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[293] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[294] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[295] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[80] = 0x01;
		break;
	case 0x184BFBF3:
		battCellU[296] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[297] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[298] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[299] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[81] = 0x01;
		break;
	case 0x184CFBF3:
		battCellU[300] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[301] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[302] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[303] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[82] = 0x01;
		break;
	case 0x184DFBF3:
		battCellU[304] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[305] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[306] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[307] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[83] = 0x01;
		break;
	case 0x184EFBF3:
		battCellU[308] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[309] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[310] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[311] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[84] = 0x01;
		break;
	case 0x184FFBF3:
		battCellU[312] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[313] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[314] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[315] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[85] = 0x01;
		break;
	case 0x1850FBF3:
		battCellU[316] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[317] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[318] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[319] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[86] = 0x01;
		break;
	case 0x1851FBF3:
		battCellU[320] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[321] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[322] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[323] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[87] = 0x01;
		break;
	case 0x1852FBF3:
		battCellU[324] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[325] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[326] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[327] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[88] = 0x01;
		break;
	case 0x1853FBF3:
		battCellU[328] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[329] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[330] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[331] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[89] = 0x01;
		break;
	case 0x1854FBF3:
		battCellU[332] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[333] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[334] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[335] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[90] = 0x01;
		break;
	case 0x1855FBF3:
		battCellU[336] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[337] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[338] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[339] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[91] = 0x01;
		break;
	case 0x1856FBF3:
		battCellU[340] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[341] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[342] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[343] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[92] = 0x01;
		break;
	case 0x1857FBF3:
		battCellU[344] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[345] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[346] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[347] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[93] = 0x01;
		break;
	case 0x1858FBF3:
		battCellU[348] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[349] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[350] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[351] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[94] = 0x01;
		break;
	case 0x1859FBF3:
		battCellU[352] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[353] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[354] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[355] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[95] = 0x01;
		break;
	case 0x185AFBF3:
		battCellU[356] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[357] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[358] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[359] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[96] = 0x01;
		break;
	case 0x185BFBF3:
		battCellU[360] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[361] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[362] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[363] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[97] = 0x01;
		break;
	case 0x185CFBF3:
		battCellU[364] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[365] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[366] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[367] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[98] = 0x01;
		break;
	case 0x185DFBF3:
		battCellU[368] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[369] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[370] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[371] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[99] = 0x01;
		break;
	case 0x185EFBF3:
		battCellU[372] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[373] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[374] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[375] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[100] = 0x01;
		break;
	case 0x185FFBF3:
		battCellU[376] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[377] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[378] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[379] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[101] = 0x01;
		break;
	case 0x1860FBF3:
		battCellU[380] = (UINT16)(((*(UINT16 *)(rawData + 0))) & 0xFFFF);
		battCellU[381] = (UINT16)(((*(UINT16 *)(rawData + 2))) & 0xFFFF);
		battCellU[382] = (UINT16)(((*(UINT16 *)(rawData + 4))) & 0xFFFF);
		battCellU[383] = (UINT16)(((*(UINT16 *)(rawData + 6))) & 0xFFFF);
		canRxFlag[102] = 0x01;
		break;
	case 0x18A0FBF3:
		battCellTemp[0] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		battCellTemp[1] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		battCellTemp[2] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		battCellTemp[3] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		battCellTemp[4] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		battCellTemp[5] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		battCellTemp[6] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		battCellTemp[7] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		canRxFlag[103] = 0x01;
		break;
	case 0x18A1FBF3:
		battCellTemp[8] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		battCellTemp[9] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		battCellTemp[10] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		battCellTemp[11] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		battCellTemp[12] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		battCellTemp[13] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		battCellTemp[14] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		battCellTemp[15] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		canRxFlag[104] = 0x01;
		break;
	case 0x18A2FBF3:
		battCellTemp[16] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		battCellTemp[17] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		battCellTemp[18] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		battCellTemp[19] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		battCellTemp[20] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		battCellTemp[21] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		battCellTemp[22] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		battCellTemp[23] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		battCellTemp[24] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		battCellTemp[25] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		battCellTemp[26] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		battCellTemp[27] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		battCellTemp[28] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		battCellTemp[29] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		battCellTemp[30] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		battCellTemp[31] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		canRxFlag[105] = 0x01;
		break;
	case 0x18A3FBF3:
		battCellTemp[32] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		battCellTemp[33] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		battCellTemp[34] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		battCellTemp[35] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		battCellTemp[36] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		battCellTemp[37] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		battCellTemp[38] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		battCellTemp[39] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		canRxFlag[106] = 0x01;
		break;
	case 0x18A4FBF3:
		battCellTemp[40] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		battCellTemp[41] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		battCellTemp[42] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		battCellTemp[43] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		battCellTemp[44] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		battCellTemp[45] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		battCellTemp[46] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		battCellTemp[47] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		canRxFlag[107] = 0x01;
		break;
	case 0x18A5FBF3:
		battCellTemp[48] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		battCellTemp[49] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		battCellTemp[50] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		battCellTemp[51] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		battCellTemp[52] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		battCellTemp[53] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		battCellTemp[54] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		battCellTemp[55] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		canRxFlag[108] = 0x01;
		break;
	case 0x18A6FBF3:
		battCellTemp[56] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		battCellTemp[57] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		battCellTemp[58] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		battCellTemp[59] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		battCellTemp[60] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		battCellTemp[61] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		battCellTemp[62] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		battCellTemp[63] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		canRxFlag[109] = 0x01;
		break;
	case 0x18FF08F3:
		mainPosRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0x3);
		preRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 0)) >> 2) & 0x3);
		mainNegRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 0)) >> 4) & 0x3);
		thrRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 0)) >> 6) & 0x3);
		ptc1RlyStatus = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0x3);
		airCondRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 1)) >> 2) & 0x3);
		dcChrg1PosRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 1)) >> 4) & 0x3);
		dcChrg1NegRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 1)) >> 6) & 0x3);
		dcChrg2PosRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0x3);
		dcChrg2NegRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 2)) >> 2) & 0x3);
		heatPosRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 2)) >> 4) & 0x3);
		heatNegRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 2)) >> 6) & 0x3);
		coolRlyStatus = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0x3);
		ptc2RlyStatus = (UINT8)(((*(UINT8 *)(rawData + 3)) >> 2) & 0x3);
		mainPosRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0x3);
		preRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 4)) >> 2) & 0x3);
		mainNegRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 4)) >> 4) & 0x3);
		thrRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 4)) >> 6) & 0x3);
		ptc1RlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0x3);
		airCondRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 5)) >> 2) & 0x3);
		dcChrg1PosRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 5)) >> 4) & 0x3);
		dcChrg1NegRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 5)) >> 6) & 0x3);
		dcChrg2PosRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0x3);
		dcChrg2NegRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 6)) >> 2) & 0x3);
		heatPosRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 6)) >> 4) & 0x3);
		heatNegRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 6)) >> 6) & 0x3);
		coolRlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0x3);
		ptc2RlyErrStatus = (UINT8)(((*(UINT8 *)(rawData + 7)) >> 2) & 0x3);
		canRxFlag[110] = 0x01;
		break;
	case 0x18FF60F3:
		accChrgAh = (UINT32)(((*(UINT32 *)(rawData + 0))) & 0xFFFFFFFF);
		accDischrgAh = (UINT32)(((*(UINT32 *)(rawData + 4))) & 0xFFFFFFFF);
		canRxFlag[111] = 0x01;
		break;
	case 0x18FF61F3:
		accChrgkWh = (UINT32)(((*(UINT32 *)(rawData + 0))) & 0xFFFFFFFF);
		accDischrgkWh = (UINT32)(((*(UINT32 *)(rawData + 4))) & 0xFFFFFFFF);
		canRxFlag[112] = 0x01;
		break;
	case 0x18FF62F3:
		battSOH = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		canRxFlag[113] = 0x01;
		break;
	case 0x18FF63F3:
		SN[0] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		SN[1] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		SN[2] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		SN[3] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		SN[4] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		SN[5] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		SN[6] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		SN[7] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		snAndVinMsgFlag = snAndVinMsgFlag | (1 << 0);
		canRxFlag[114] = 0x01;
		break;
	case 0x18FF64F3:
		SN[8] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		SN[9] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		SN[10] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		SN[11] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		SN[12] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		SN[13] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		SN[14] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		SN[15] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		snAndVinMsgFlag = snAndVinMsgFlag | (1 << 1);
		canRxFlag[115] = 0x01;
		break;
	case 0x18FF65F3:
		SN[16] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		SN[17] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		SN[18] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		SN[19] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		SN[20] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		SN[21] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		SN[22] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		SN[23] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		snAndVinMsgFlag = snAndVinMsgFlag | (1 << 2);
		canRxFlag[116] = 0x01;
		break;
	case 0x18FF66F3:
		accRecvryChrgAh = (UINT32)(((*(UINT32 *)(rawData + 0))) & 0xFFFFFFFF);
		accRecvryChrgkWh = (UINT32)(((*(UINT32 *)(rawData + 4))) & 0xFFFFFFFF);
		canRxFlag[117] = 0x01;
		break;
	case 0x18FF67F3:
		accStationChrgAh = (UINT32)(((*(UINT32 *)(rawData + 0))) & 0xFFFFFFFF);
		accStationChrgkWh = (UINT32)(((*(UINT32 *)(rawData + 4))) & 0xFFFFFFFF);
		canRxFlag[118] = 0x01;
		break;
	case 0x18FF68F3:
		accGunChrgAh = (UINT32)(((*(UINT32 *)(rawData + 0))) & 0xFFFFFFFF);
		accGunChrgkWh = (UINT32)(((*(UINT32 *)(rawData + 4))) & 0xFFFFFFFF);
		canRxFlag[119] = 0x01;
		break;
	case 0x18FF69F3:
		sglChrgAh = (UINT32)(((*(UINT32 *)(rawData + 0))) & 0xFFFFFFFF);
		sglChrgkWh = (UINT32)(((*(UINT32 *)(rawData + 4))) & 0xFFFFFFFF);
		canRxFlag[120] = 0x01;
		break;
	case 0x18FF10D0:
		bmsHVOn = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0x3);
		canRxFlag[121] = 0x01;
		break;
	case 0x18FF20EF:
		vcuDCVol = (UINT16)(((*(UINT16 *)(rawData + 1))) & 0xFFFF);
		canRxFlag[122] = 0x01;
		break;
	case 0x18FF14A3:
		acRelayStatus = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0x3);
		ptcRelayStatus = (UINT8)(((*(UINT8 *)(rawData + 0)) >> 2) & 0x3);
		mainRelayStatus = (UINT8)(((*(UINT8 *)(rawData + 0)) >> 3) & 0x3);
		preRelayStatus = (UINT8)(((*(UINT8 *)(rawData + 0)) >> 4) & 0x3);
		ptc2RelayStatus = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0x3);
		acRelayErrorStatus = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0x3);
		ptcRelayErrorStatus = (UINT8)(((*(UINT8 *)(rawData + 4)) >> 2) & 0x3);
		mainRelayErrorStatus = (UINT8)(((*(UINT8 *)(rawData + 4)) >> 4) & 0x3);
		preRelayErrorStatus = (UINT8)(((*(UINT8 *)(rawData + 4)) >> 6) & 0x3);
		hvLockErrorStatus = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0x3);
		ptc2RelayErrorStatus = (UINT8)(((*(UINT8 *)(rawData + 5)) >> 2) & 0x3);
		canRxFlag[123] = 0x01;
		break;
	case 0x18FF11F4:
		ebcStatus = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		ebcAskHVOn = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0x1);
		ebcAskHVOff = (UINT8)(((*(UINT8 *)(rawData + 1)) >> 1) & 0x1);
		retainLockSignal = (UINT8)(((*(UINT8 *)(rawData + 1)) >> 3) & 0x1);
		dischargeLockSignal = (UINT8)(((*(UINT8 *)(rawData + 1)) >> 5) & 0x1);
		chargeLockSignal = (UINT8)(((*(UINT8 *)(rawData + 1)) >> 6) & 0x1);
		errorClass = (UINT8)(((*(UINT16 *)(rawData + 2)) >> 2) & 0xFF);
		errorCode1 = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		errorCode2 = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		chargeFlag = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		exchangeBattAirPressure = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		lifeSignal = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		canRxFlag[124] = 0x01;
		break;
	case 0x18FF09D0:
		vehicleStatus = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0x3);
		currentGearPosition = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0x1F);
		canRxFlag[125] = 0x01;
		break;
	case 0x18FEF1D0:
		parkingBreakStatus = (UINT8)(((*(UINT8 *)(rawData + 0)) >> 2) & 0x3);
		breakingStatus = (UINT8)(((*(UINT8 *)(rawData + 3)) >> 4) & 0x3);
		canRxFlag[126] = 0x01;
		break;
	case 0x18FF55D0:
		if (*rawData >= 1 && *rawData <= 3)
		{
			for (UINT8 i = 0; i < 7; i++)
			{
				if (i + ((*rawData) - 1) * 7 < sizeof(VIN))
				{
					VIN[i + ((*rawData) - 1) * 7] = *(rawData + i + 1) & 0xFF;
					//printf("VIN[%d] = %x\n",i+((*rawData)-1)*7,VIN[i+((*rawData)-1)*7]);
				}
				else
				{
					break;
				}
			}
			snAndVinMsgFlag = snAndVinMsgFlag | (1 << ((*rawData) + 3));
		}
		canRxFlag[127] = 0x01;
		break;
	case 0x18FEAE17:
		frontBreakingPressure = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		backBreakingPressure = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		frontBreakingPressureErrorStatus = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0x3);
		backBreakingPressureErrorStatus = (UINT8)(((*(UINT8 *)(rawData + 6)) >> 2) & 0x3);
		canRxFlag[128] = 0x01;
		break;
	case 0x18FEC117:
		ODO = (UINT32)(((*(UINT32 *)(rawData + 0))) & 0xFFFFFFFF);
		canRxFlag[129] = 0x01;
		break;
	case 0x18FF15A0:
		dcdcErrorClass = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0x7);
		dcdcWorkStatus = (UINT8)(((*(UINT8 *)(rawData + 5)) >> 3) & 0x3);
		canRxFlag[130] = 0x01;
		break;
	case 0x18FF16A1:
		mainElectricityErrorClass = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0x7);
		pumpWorkStatus = (UINT8)(((*(UINT8 *)(rawData + 5)) >> 3) & 0x3);
		canRxFlag[131] = 0x01;
		break;
	case 0x18FF17A2:
		elecAirCompressorErrorStatus = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0x7);
		elecAirCompressorWrokStatus = (UINT8)(((*(UINT8 *)(rawData + 5)) >> 3) & 0x3);
		canRxFlag[132] = 0x01;
		break;
	default:
		break;
	}
	if (snAndVinMsgFlag & 0x03 == 3)
		canSNMsgRxCmpltFlag = true;
	if ((snAndVinMsgFlag >> 4) & 0x07 == 7)
		canVINMsgRxCmpltFlag = true;
}

/***********************************************************************************************************************
 * 周期性报文诊�?
 * 输入：报文ID
 * 输出�?-
 * 处理：周期性诊断CAN报文是否丢失
***********************************************************************************************************************/
void canRxDiagnose(void)
{

	//printf("timer in = %d\n", TimeCounter);

	if (TimeCounter % 1 == 0) //period <=100ms
	{
		canRxErrorCounter[0]++; //can msg 0x18FF06F3
		//if(canRxErrorCounter[0]>=13)
		//printf("can msg 0x%x lost,cycle time100ms\n",COMInTable[0]);
		canRxErrorCounter[1]++; //can msg 0x18FF07F3
		//if(canRxErrorCounter[1]>=13)
		//printf("can msg 0x%x lost,cycle time50ms\n",COMInTable[1]);
		canRxErrorCounter[110]++; //can msg 0x18FF08F3
		//if(canRxErrorCounter[110]>=13)
		//printf("can msg 0x%x lost,cycle time100ms\n",COMInTable[110]);
		canRxErrorCounter[121]++; //can msg 0x18FF10D0
		//if(canRxErrorCounter[121]>=13)
		//printf("can msg 0x%x lost,cycle time100ms\n",COMInTable[121]);
		canRxErrorCounter[122]++; //can msg 0x18FF20EF
		//if(canRxErrorCounter[122]>=13)
		//printf("can msg 0x%x lost,cycle time100ms\n",COMInTable[122]);
		canRxErrorCounter[123]++; //can msg 0x18FF14A3
		//if(canRxErrorCounter[123]>=13)
		//printf("can msg 0x%x lost,cycle time100ms\n",COMInTable[123]);
		canRxErrorCounter[124]++; //can msg 0x18FF11F4
		//if(canRxErrorCounter[124]>=13)
		//printf("can msg 0x%x lost,cycle time100ms\n",COMInTable[124]);
		canRxErrorCounter[125]++; //can msg 0x18FF09D0
		//if(canRxErrorCounter[125]>=13)
		//printf("can msg 0x%x lost,cycle time100ms\n",COMInTable[125]);
		canRxErrorCounter[126]++; //can msg 0x18FEF1D0
								  //if(canRxErrorCounter[126]>=13)
								  //printf("can msg 0x%x lost,cycle time100ms\n",COMInTable[126]);
	}
	if (TimeCounter % 2 == 0) //period ==200ms
	{
		canRxErrorCounter[128]++; //can msg 0x18FEAE17
								  //if(canRxErrorCounter[128]>=13)
								  //printf("can msg 0x%x lost,cycle time200ms\n",COMInTable[128]);
	}
	if (TimeCounter % 5 == 0) //period ==500ms
	{
		canRxErrorCounter[2]++; //can msg 0x18FF30F3
		// if (canRxErrorCounter[2] >= 25)
		// 	printf("can msg 0x%x lost,cycle time500ms\n", COMInTable[2]);
		canRxErrorCounter[130]++; //can msg 0x18FF15A0
		//if(canRxErrorCounter[130]>=13)
		//printf("can msg 0x%x lost,cycle time500ms\n",COMInTable[130]);
		canRxErrorCounter[131]++; //can msg 0x18FF16A1
		//if(canRxErrorCounter[131]>=13)
		//printf("can msg 0x%x lost,cycle time500ms\n",COMInTable[131]);
		canRxErrorCounter[132]++; //can msg 0x18FF17A2
								  //if(canRxErrorCounter[132]>=13)
								  //printf("can msg 0x%x lost,cycle time500ms\n",COMInTable[132]);
	}
	if (TimeCounter % 10 == 0) //period ==1000ms
	{
		canRxErrorCounter[3]++; //can msg 0x18FF51F3
		//if(canRxErrorCounter[3]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[3]);
		canRxErrorCounter[4]++; //can msg 0x18FF52F3
		//if(canRxErrorCounter[4]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[4]);
		canRxErrorCounter[5]++; //can msg 0x18FF53F3
		//if(canRxErrorCounter[5]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[5]);
		canRxErrorCounter[6]++; //can msg 0x18FF54F3
		//if(canRxErrorCounter[6]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[6]);
		canRxErrorCounter[7]++; //can msg 0x1801FBF3
		//if(canRxErrorCounter[7]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[7]);
		canRxErrorCounter[8]++; //can msg 0x1802FBF3
		//if(canRxErrorCounter[8]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[8]);
		canRxErrorCounter[9]++; //can msg 0x1803FBF3
		//if(canRxErrorCounter[9]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[9]);
		canRxErrorCounter[10]++; //can msg 0x1804FBF3
		//if(canRxErrorCounter[10]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[10]);
		canRxErrorCounter[11]++; //can msg 0x1805FBF3
		//if(canRxErrorCounter[11]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[11]);
		canRxErrorCounter[12]++; //can msg 0x1806FBF3
		//if(canRxErrorCounter[12]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[12]);
		canRxErrorCounter[13]++; //can msg 0x1807FBF3
		//if(canRxErrorCounter[13]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[13]);
		canRxErrorCounter[14]++; //can msg 0x1808FBF3
		//if(canRxErrorCounter[14]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[14]);
		canRxErrorCounter[15]++; //can msg 0x1809FBF3
		//if(canRxErrorCounter[15]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[15]);
		canRxErrorCounter[16]++; //can msg 0x180AFBF3
		//if(canRxErrorCounter[16]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[16]);
		canRxErrorCounter[17]++; //can msg 0x180BFBF3
		//if(canRxErrorCounter[17]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[17]);
		canRxErrorCounter[18]++; //can msg 0x180CFBF3
		//if(canRxErrorCounter[18]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[18]);
		canRxErrorCounter[19]++; //can msg 0x180DFBF3
		//if(canRxErrorCounter[19]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[19]);
		canRxErrorCounter[20]++; //can msg 0x180EFBF3
		//if(canRxErrorCounter[20]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[20]);
		canRxErrorCounter[21]++; //can msg 0x180FFBF3
		//if(canRxErrorCounter[21]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[21]);
		canRxErrorCounter[22]++; //can msg 0x1810FBF3
		//if(canRxErrorCounter[22]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[22]);
		canRxErrorCounter[23]++; //can msg 0x1811FBF3
		//if(canRxErrorCounter[23]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[23]);
		canRxErrorCounter[24]++; //can msg 0x1812FBF3
		//if(canRxErrorCounter[24]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[24]);
		canRxErrorCounter[25]++; //can msg 0x1813FBF3
		//if(canRxErrorCounter[25]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[25]);
		canRxErrorCounter[26]++; //can msg 0x1814FBF3
		//if(canRxErrorCounter[26]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[26]);
		canRxErrorCounter[27]++; //can msg 0x1815FBF3
		//if(canRxErrorCounter[27]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[27]);
		canRxErrorCounter[28]++; //can msg 0x1816FBF3
		//if(canRxErrorCounter[28]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[28]);
		canRxErrorCounter[29]++; //can msg 0x1817FBF3
		//if(canRxErrorCounter[29]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[29]);
		canRxErrorCounter[30]++; //can msg 0x1818FBF3
		//if(canRxErrorCounter[30]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[30]);
		canRxErrorCounter[31]++; //can msg 0x1819FBF3
		//if(canRxErrorCounter[31]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[31]);
		canRxErrorCounter[32]++; //can msg 0x181AFBF3
		//if(canRxErrorCounter[32]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[32]);
		canRxErrorCounter[33]++; //can msg 0x181BFBF3
		//if(canRxErrorCounter[33]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[33]);
		canRxErrorCounter[34]++; //can msg 0x181CFBF3
		//if(canRxErrorCounter[34]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[34]);
		canRxErrorCounter[35]++; //can msg 0x181DFBF3
		//if(canRxErrorCounter[35]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[35]);
		canRxErrorCounter[36]++; //can msg 0x181EFBF3
		//if(canRxErrorCounter[36]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[36]);
		canRxErrorCounter[37]++; //can msg 0x181FFBF3
		//if(canRxErrorCounter[37]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[37]);
		canRxErrorCounter[38]++; //can msg 0x1820FBF3
		//if(canRxErrorCounter[38]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[38]);
		canRxErrorCounter[39]++; //can msg 0x1821FBF3
		//if(canRxErrorCounter[39]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[39]);
		canRxErrorCounter[40]++; //can msg 0x1822FBF3
		//if(canRxErrorCounter[40]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[40]);
		canRxErrorCounter[41]++; //can msg 0x1823FBF3
		//if(canRxErrorCounter[41]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[41]);
		canRxErrorCounter[42]++; //can msg 0x1824FBF3
		//if(canRxErrorCounter[42]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[42]);
		canRxErrorCounter[43]++; //can msg 0x1825FBF3
		//if(canRxErrorCounter[43]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[43]);
		canRxErrorCounter[44]++; //can msg 0x1826FBF3
		//if(canRxErrorCounter[44]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[44]);
		canRxErrorCounter[45]++; //can msg 0x1827FBF3
		//if(canRxErrorCounter[45]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[45]);
		canRxErrorCounter[46]++; //can msg 0x1828FBF3
		//if(canRxErrorCounter[46]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[46]);
		canRxErrorCounter[47]++; //can msg 0x1829FBF3
		//if(canRxErrorCounter[47]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[47]);
		canRxErrorCounter[48]++; //can msg 0x182AFBF3
		//if(canRxErrorCounter[48]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[48]);
		canRxErrorCounter[49]++; //can msg 0x182BFBF3
		//if(canRxErrorCounter[49]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[49]);
		canRxErrorCounter[50]++; //can msg 0x182CFBF3
		//if(canRxErrorCounter[50]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[50]);
		canRxErrorCounter[51]++; //can msg 0x182DFBF3
		//if(canRxErrorCounter[51]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[51]);
		canRxErrorCounter[52]++; //can msg 0x182EFBF3
		//if(canRxErrorCounter[52]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[52]);
		canRxErrorCounter[53]++; //can msg 0x182FFBF3
		//if(canRxErrorCounter[53]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[53]);
		canRxErrorCounter[54]++; //can msg 0x1830FBF3
		//if(canRxErrorCounter[54]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[54]);
		canRxErrorCounter[55]++; //can msg 0x1831FBF3
		//if(canRxErrorCounter[55]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[55]);
		canRxErrorCounter[56]++; //can msg 0x1832FBF3
		//if(canRxErrorCounter[56]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[56]);
		canRxErrorCounter[57]++; //can msg 0x1833FBF3
		//if(canRxErrorCounter[57]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[57]);
		canRxErrorCounter[58]++; //can msg 0x1834FBF3
		//if(canRxErrorCounter[58]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[58]);
		canRxErrorCounter[59]++; //can msg 0x1835FBF3
		//if(canRxErrorCounter[59]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[59]);
		canRxErrorCounter[60]++; //can msg 0x1836FBF3
		//if(canRxErrorCounter[60]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[60]);
		canRxErrorCounter[61]++; //can msg 0x1837FBF3
		//if(canRxErrorCounter[61]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[61]);
		canRxErrorCounter[62]++; //can msg 0x1838FBF3
		//if(canRxErrorCounter[62]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[62]);
		canRxErrorCounter[63]++; //can msg 0x1839FBF3
		//if(canRxErrorCounter[63]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[63]);
		canRxErrorCounter[64]++; //can msg 0x183AFBF3
		//if(canRxErrorCounter[64]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[64]);
		canRxErrorCounter[65]++; //can msg 0x183BFBF3
		//if(canRxErrorCounter[65]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[65]);
		canRxErrorCounter[66]++; //can msg 0x183CFBF3
		//if(canRxErrorCounter[66]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[66]);
		canRxErrorCounter[67]++; //can msg 0x183DFBF3
		//if(canRxErrorCounter[67]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[67]);
		canRxErrorCounter[68]++; //can msg 0x183EFBF3
		//if(canRxErrorCounter[68]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[68]);
		canRxErrorCounter[69]++; //can msg 0x183FFBF3
		//if(canRxErrorCounter[69]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[69]);
		canRxErrorCounter[70]++; //can msg 0x1840FBF3
		//if(canRxErrorCounter[70]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[70]);
		canRxErrorCounter[71]++; //can msg 0x1841FBF3
		//if(canRxErrorCounter[71]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[71]);
		canRxErrorCounter[72]++; //can msg 0x1842FBF3
		//if(canRxErrorCounter[72]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[72]);
		canRxErrorCounter[73]++; //can msg 0x1843FBF3
		//if(canRxErrorCounter[73]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[73]);
		canRxErrorCounter[74]++; //can msg 0x1844FBF3
		//if(canRxErrorCounter[74]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[74]);
		canRxErrorCounter[75]++; //can msg 0x1845FBF3
		//if(canRxErrorCounter[75]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[75]);
		canRxErrorCounter[76]++; //can msg 0x1846FBF3
		//if(canRxErrorCounter[76]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[76]);
		canRxErrorCounter[77]++; //can msg 0x1847FBF3
		//if(canRxErrorCounter[77]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[77]);
		canRxErrorCounter[78]++; //can msg 0x1848FBF3
		//if(canRxErrorCounter[78]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[78]);
		canRxErrorCounter[79]++; //can msg 0x1849FBF3
		//if(canRxErrorCounter[79]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[79]);
		canRxErrorCounter[80]++; //can msg 0x184AFBF3
		//if(canRxErrorCounter[80]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[80]);
		canRxErrorCounter[81]++; //can msg 0x184BFBF3
		//if(canRxErrorCounter[81]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[81]);
		canRxErrorCounter[82]++; //can msg 0x184CFBF3
		//if(canRxErrorCounter[82]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[82]);
		canRxErrorCounter[83]++; //can msg 0x184DFBF3
		//if(canRxErrorCounter[83]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[83]);
		canRxErrorCounter[84]++; //can msg 0x184EFBF3
		//if(canRxErrorCounter[84]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[84]);
		canRxErrorCounter[85]++; //can msg 0x184FFBF3
		//if(canRxErrorCounter[85]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[85]);
		canRxErrorCounter[86]++; //can msg 0x1850FBF3
		//if(canRxErrorCounter[86]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[86]);
		canRxErrorCounter[87]++; //can msg 0x1851FBF3
		//if(canRxErrorCounter[87]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[87]);
		canRxErrorCounter[88]++; //can msg 0x1852FBF3
		//if(canRxErrorCounter[88]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[88]);
		canRxErrorCounter[89]++; //can msg 0x1853FBF3
		//if(canRxErrorCounter[89]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[89]);
		canRxErrorCounter[90]++; //can msg 0x1854FBF3
		//if(canRxErrorCounter[90]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[90]);
		canRxErrorCounter[91]++; //can msg 0x1855FBF3
		//if(canRxErrorCounter[91]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[91]);
		canRxErrorCounter[92]++; //can msg 0x1856FBF3
		//if(canRxErrorCounter[92]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[92]);
		canRxErrorCounter[93]++; //can msg 0x1857FBF3
		//if(canRxErrorCounter[93]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[93]);
		canRxErrorCounter[94]++; //can msg 0x1858FBF3
		//if(canRxErrorCounter[94]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[94]);
		canRxErrorCounter[95]++; //can msg 0x1859FBF3
		//if(canRxErrorCounter[95]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[95]);
		canRxErrorCounter[96]++; //can msg 0x185AFBF3
		//if(canRxErrorCounter[96]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[96]);
		canRxErrorCounter[97]++; //can msg 0x185BFBF3
		//if(canRxErrorCounter[97]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[97]);
		canRxErrorCounter[98]++; //can msg 0x185CFBF3
		//if(canRxErrorCounter[98]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[98]);
		canRxErrorCounter[99]++; //can msg 0x185DFBF3
		//if(canRxErrorCounter[99]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[99]);
		canRxErrorCounter[100]++; //can msg 0x185EFBF3
		//if(canRxErrorCounter[100]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[100]);
		canRxErrorCounter[101]++; //can msg 0x185FFBF3
		//if(canRxErrorCounter[101]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[101]);
		canRxErrorCounter[102]++; //can msg 0x1860FBF3
		//if(canRxErrorCounter[102]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[102]);
		canRxErrorCounter[103]++; //can msg 0x18A0FBF3
		//if(canRxErrorCounter[103]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[103]);
		canRxErrorCounter[104]++; //can msg 0x18A1FBF3
		//if(canRxErrorCounter[104]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[104]);
		canRxErrorCounter[105]++; //can msg 0x18A2FBF3
		//if(canRxErrorCounter[105]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[105]);
		canRxErrorCounter[106]++; //can msg 0x18A3FBF3
		//if(canRxErrorCounter[106]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[106]);
		canRxErrorCounter[107]++; //can msg 0x18A4FBF3
		//if(canRxErrorCounter[107]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[107]);
		canRxErrorCounter[108]++; //can msg 0x18A5FBF3
		//if(canRxErrorCounter[108]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[108]);
		canRxErrorCounter[109]++; //can msg 0x18A6FBF3
		//if(canRxErrorCounter[109]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[109]);
		canRxErrorCounter[111]++; //can msg 0x18FF60F3
		//if(canRxErrorCounter[111]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[111]);
		canRxErrorCounter[112]++; //can msg 0x18FF61F3
		//if(canRxErrorCounter[112]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[112]);
		canRxErrorCounter[113]++; //can msg 0x18FF62F3
		//if(canRxErrorCounter[113]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[113]);
		canRxErrorCounter[117]++; //can msg 0x18FF66F3
		//if(canRxErrorCounter[117]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[117]);
		canRxErrorCounter[118]++; //can msg 0x18FF67F3
		//if(canRxErrorCounter[118]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[118]);
		canRxErrorCounter[119]++; //can msg 0x18FF68F3
		//if(canRxErrorCounter[119]>=13)
		//printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[119]);
		canRxErrorCounter[120]++; //can msg 0x18FF69F3
								  //if(canRxErrorCounter[120]>=13)
								  //printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[120]);
	}
	if (TimeCounter % 20 == 0) //period ==2000ms
	{
		canRxErrorCounter[127]++; //can msg 0x18FF55D0
								  //if(canRxErrorCounter[127]>=13)
								  //printf("can msg 0x%x lost,cycle time2000ms\n",COMInTable[127]);
	}
	if (TimeCounter % 30 == 0) //period ==3000ms
	{
		canRxErrorCounter[114]++; //can msg 0x18FF63F3
		//if(canRxErrorCounter[114]>=13)
		//printf("can msg 0x%x lost,cycle time3000ms\n",COMInTable[114]);
		canRxErrorCounter[115]++; //can msg 0x18FF64F3
		//if(canRxErrorCounter[115]>=13)
		//printf("can msg 0x%x lost,cycle time3000ms\n",COMInTable[115]);
		canRxErrorCounter[116]++; //can msg 0x18FF65F3
								  //if(canRxErrorCounter[116]>=13)
								  //printf("can msg 0x%x lost,cycle time3000ms\n",COMInTable[116]);
	}
	if (TimeCounter % 50 == 0) //period ==5000ms
	{
		canRxErrorCounter[129]++; //can msg 0x18FEC117
								  //if(canRxErrorCounter[129]>=13)
								  //printf("can msg 0x%x lost,cycle time5000ms\n",COMInTable[129]);
	}

	for (int i = 0; i < sizeof(COMInTable) / 4; i++)
	{
		if (canRxFlag[i] == 1) //received msg, and clear the error conter
		{
			canRxErrorCounter[i] = 0;
			canRxFlag[i] = 0;
		}

		if (canRxErrorCounter[i] < 3)
		{
			canRxShortError[i] = 0;
			canRxLongError[i] = 0;
		}
		else if (canRxErrorCounter[i] >= 3 && canRxErrorCounter[i] < 20)
		{
			canRxShortError[i] = 1;
			canRxLongError[i] = 0;
		}
		else if (canRxErrorCounter[i] >= 20)
		{
			canRxShortError[i] = 0;
			canRxLongError[i] = 1;
			canRxMsgSetInvalidValue(COMInTable[i]);
			canRxErrorCounter[i] = 0;
		}
		else if (canRxErrorCounter[i] == 0xFF)
		{
			canRxErrorCounter[i] = 0xFE;
		}
	}

	if (canRxLongError[114] | canRxLongError[115])
	{
		canSNMsgLostFlag = true;
	}
	else
	{
		canSNMsgLostFlag = false;
	}

	//printf("timer out = %d\n",TimeCounter);
	//printf("\n");
}

/***********************************************************************************************************************
 * 周期性报文诊�?
 * 输入：报文ID
 * 输出�?-
 * 处理：周期性诊断CAN报文是否丢失
***********************************************************************************************************************/
void canTxTest(void)
{
	CAN_Msg_Type CanMsg;
	UINT32 timer = TimeCounter;
	CanMsg.DLC = 0x08;
	for (int i = 0; i < 8; i++)
	{
		CanMsg.Data[i] = 0x30 + i;
	}
	printf("TimeCounter = %d\n", TimeCounter);
	if (timer % 1 == 0) //period <=100ms
	{
		printf("send can 100ms msg\n");
		CanMsg.Id = 0x18FF06F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF07F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF08F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF10D0;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF20EF;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF14A3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF11F4;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF09D0;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FEF1D0;
		HAL_Can_Transmit(CanMsg);
	}
	if (timer % 2 == 0) //period ==200ms
	{
		printf("send can 200ms msg\n");
		CanMsg.Id = 0x18FEAE17;
		HAL_Can_Transmit(CanMsg);
	}
	if (timer % 5 == 0) //period ==500ms
	{
		printf("send can 500ms msg\n");
		CanMsg.Id = 0x18FF30F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF15A0;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF16A1;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF17A2;
		HAL_Can_Transmit(CanMsg);
	}
	if (timer % 10 == 0) //period ==1000ms
	{
		printf("send can 1000ms msg\n");
		CanMsg.Id = 0x18FF51F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF52F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF53F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF54F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1801FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1802FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1803FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1804FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1805FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1806FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1807FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1808FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1809FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x180AFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x180BFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x180CFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x180DFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x180EFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x180FFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1810FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1811FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1812FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1813FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1814FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1815FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1816FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1817FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1818FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1819FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x181AFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x181BFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x181CFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x181DFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x181EFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x181FFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1820FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1821FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1822FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1823FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1824FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1825FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1826FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1827FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1828FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1829FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x182AFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x182BFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x182CFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x182DFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x182EFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x182FFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1830FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1831FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1832FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1833FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1834FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1835FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1836FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1837FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1838FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1839FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x183AFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x183BFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x183CFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x183DFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x183EFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x183FFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1840FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1841FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1842FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1843FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1844FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1845FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1846FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1847FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1848FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1849FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x184AFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x184BFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x184CFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x184DFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x184EFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x184FFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1850FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1851FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1852FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1853FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1854FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1855FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1856FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1857FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1858FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1859FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x185AFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x185BFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x185CFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x185DFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x185EFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x185FFBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x1860FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18A0FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18A1FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18A2FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18A3FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18A4FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18A5FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18A6FBF3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF60F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF61F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF62F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF66F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF67F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF68F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF69F3;
		HAL_Can_Transmit(CanMsg);
	}
	if (timer % 20 == 0) //period ==2000ms
	{
		printf("send can 2000ms msg\n");
		CanMsg.Id = 0x18FF55D0;
		HAL_Can_Transmit(CanMsg);
	}
	if (timer % 30 == 0) //period ==3000ms
	{
		printf("send can 3000ms msg\n");
		CanMsg.Id = 0x18FF63F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF64F3;
		HAL_Can_Transmit(CanMsg);
		CanMsg.Id = 0x18FF65F3;
		HAL_Can_Transmit(CanMsg);
	}
	if (timer % 50 == 0) //period ==5000ms
	{
		printf("send can 5000ms msg\n");
		CanMsg.Id = 0x18FEC117;
		HAL_Can_Transmit(CanMsg);
	}
}

/***********************************************************************************************************************
 * 报文序号查找
 * 输入：报文ID
 * 输出：报文ID在COMInTable中的序号
 * 处理�?-
***********************************************************************************************************************/
UINT8 canCOMInTableIndexFind(UINT32 canID)
{
	UINT8 index = 0xFF;
	for (int i = 0; i < sizeof(COMInTable) / 4; i++)
	{
		if (canID == COMInTable[i])
		{
			index = i;
			break;
		}
	}
	return index;
}

/***********************************************************************************************************************
 * 报文长时丢帧，数据置为无效�?
 * 输入：报文ID
 * 输出�?-
 * 处理：报文长时丢帧后，对应的ID的信号值为无效�?
***********************************************************************************************************************/
void canRxMsgSetInvalidValue(UINT32 ID)
{
	switch (ID)
	{
	case 0x18FF06F3:
		bmsStatus = 0xFF;
		bmsErrClass = 0xFF;
		chrgConctStatus = 0xFF;
		highVolPwrDwnReq = 0xFF;
		chrgStatus = 0xFF;
		bmsErrNum = 0xFF;
		bmsLife = 0xFF;
		break;
	case 0x18FF07F3:
		maxChrgCurrAllowed = 0xFFFF;
		maxDischrgCurrAllowed = 0xFFFF;
		break;
	case 0x18FF30F3:
		battSoc = 0xFF;
		packTotalVol = 0xFFFF;
		packTotalCurr = 0xFFFF;
		insulationR = 0xFFFF;
		break;
	case 0x18FF51F3:
		maxCellVol = 0xFFFF;
		minCellVol = 0xFFFF;
		maxCellTemp = 0xFF;
		minCellTemp = 0xFF;
		avgCellTemp = 0xFF;
		break;
	case 0x18FF52F3:
		maxVolSubsysCode = 0xFF;
		maxVolCellCode = 0xFFFF;
		minVolSubsysCode = 0xFF;
		minVoCelllCode = 0xFFFF;
		break;
	case 0x18FF53F3:
		maxTempSubsysCode = 0xFF;
		maxTempCellCode = 0xFF;
		minTempSubsysCode = 0xFF;
		minTempCellCode = 0xFF;
		break;
	case 0x18FF54F3:
		numOfChrgableSubsys = 0xFF;
		lengthOfChrgableSysCode = 0xFF;
		chrgableSysCode = 0xFF;
		chrgableSubsysCode = 0xFF;
		//numOfCells =0xFFFF;
		//numOfCellTemp =0xFF;
		numOfBattErr = 0xFF;
		break;
	case 0x1801FBF3:
		battCellU[0] = 0xFFFF;
		battCellU[1] = 0xFFFF;
		battCellU[2] = 0xFFFF;
		battCellU[3] = 0xFFFF;
		break;
	case 0x1802FBF3:
		battCellU[4] = 0xFFFF;
		battCellU[5] = 0xFFFF;
		battCellU[6] = 0xFFFF;
		battCellU[7] = 0xFFFF;
		break;
	case 0x1803FBF3:
		battCellU[8] = 0xFFFF;
		battCellU[9] = 0xFFFF;
		battCellU[10] = 0xFFFF;
		battCellU[11] = 0xFFFF;
		break;
	case 0x1804FBF3:
		battCellU[12] = 0xFFFF;
		battCellU[13] = 0xFFFF;
		battCellU[14] = 0xFFFF;
		battCellU[15] = 0xFFFF;
		break;
	case 0x1805FBF3:
		battCellU[16] = 0xFFFF;
		battCellU[17] = 0xFFFF;
		battCellU[18] = 0xFFFF;
		battCellU[19] = 0xFFFF;
		break;
	case 0x1806FBF3:
		battCellU[20] = 0xFFFF;
		battCellU[21] = 0xFFFF;
		battCellU[22] = 0xFFFF;
		battCellU[23] = 0xFFFF;
		break;
	case 0x1807FBF3:
		battCellU[24] = 0xFFFF;
		battCellU[25] = 0xFFFF;
		battCellU[26] = 0xFFFF;
		battCellU[27] = 0xFFFF;
		break;
	case 0x1808FBF3:
		battCellU[28] = 0xFFFF;
		battCellU[29] = 0xFFFF;
		battCellU[30] = 0xFFFF;
		battCellU[31] = 0xFFFF;
		break;
	case 0x1809FBF3:
		battCellU[32] = 0xFFFF;
		battCellU[33] = 0xFFFF;
		battCellU[34] = 0xFFFF;
		battCellU[35] = 0xFFFF;
		break;
	case 0x180AFBF3:
		battCellU[36] = 0xFFFF;
		battCellU[37] = 0xFFFF;
		battCellU[38] = 0xFFFF;
		battCellU[39] = 0xFFFF;
		break;
	case 0x180BFBF3:
		battCellU[40] = 0xFFFF;
		battCellU[41] = 0xFFFF;
		battCellU[42] = 0xFFFF;
		battCellU[43] = 0xFFFF;
		break;
	case 0x180CFBF3:
		battCellU[44] = 0xFFFF;
		battCellU[45] = 0xFFFF;
		battCellU[46] = 0xFFFF;
		battCellU[47] = 0xFFFF;
		break;
	case 0x180DFBF3:
		battCellU[48] = 0xFFFF;
		battCellU[49] = 0xFFFF;
		battCellU[50] = 0xFFFF;
		battCellU[51] = 0xFFFF;
		break;
	case 0x180EFBF3:
		battCellU[52] = 0xFFFF;
		battCellU[53] = 0xFFFF;
		battCellU[54] = 0xFFFF;
		battCellU[55] = 0xFFFF;
		break;
	case 0x180FFBF3:
		battCellU[56] = 0xFFFF;
		battCellU[57] = 0xFFFF;
		battCellU[58] = 0xFFFF;
		battCellU[59] = 0xFFFF;
		break;
	case 0x1810FBF3:
		battCellU[60] = 0xFFFF;
		battCellU[61] = 0xFFFF;
		battCellU[62] = 0xFFFF;
		battCellU[63] = 0xFFFF;
		break;
	case 0x1811FBF3:
		battCellU[64] = 0xFFFF;
		battCellU[65] = 0xFFFF;
		battCellU[66] = 0xFFFF;
		battCellU[67] = 0xFFFF;
		break;
	case 0x1812FBF3:
		battCellU[68] = 0xFFFF;
		battCellU[69] = 0xFFFF;
		battCellU[70] = 0xFFFF;
		battCellU[71] = 0xFFFF;
		break;
	case 0x1813FBF3:
		battCellU[72] = 0xFFFF;
		battCellU[73] = 0xFFFF;
		battCellU[74] = 0xFFFF;
		battCellU[75] = 0xFFFF;
		break;
	case 0x1814FBF3:
		battCellU[76] = 0xFFFF;
		battCellU[77] = 0xFFFF;
		battCellU[78] = 0xFFFF;
		battCellU[79] = 0xFFFF;
		break;
	case 0x1815FBF3:
		battCellU[80] = 0xFFFF;
		battCellU[81] = 0xFFFF;
		battCellU[82] = 0xFFFF;
		battCellU[83] = 0xFFFF;
		break;
	case 0x1816FBF3:
		battCellU[84] = 0xFFFF;
		battCellU[85] = 0xFFFF;
		battCellU[86] = 0xFFFF;
		battCellU[87] = 0xFFFF;
		break;
	case 0x1817FBF3:
		battCellU[88] = 0xFFFF;
		battCellU[89] = 0xFFFF;
		battCellU[90] = 0xFFFF;
		battCellU[91] = 0xFFFF;
		break;
	case 0x1818FBF3:
		battCellU[92] = 0xFFFF;
		battCellU[93] = 0xFFFF;
		battCellU[94] = 0xFFFF;
		battCellU[95] = 0xFFFF;
		break;
	case 0x1819FBF3:
		battCellU[96] = 0xFFFF;
		battCellU[97] = 0xFFFF;
		battCellU[98] = 0xFFFF;
		battCellU[99] = 0xFFFF;
		break;
	case 0x181AFBF3:
		battCellU[100] = 0xFFFF;
		battCellU[101] = 0xFFFF;
		battCellU[102] = 0xFFFF;
		battCellU[103] = 0xFFFF;
		break;
	case 0x181BFBF3:
		battCellU[104] = 0xFFFF;
		battCellU[105] = 0xFFFF;
		battCellU[106] = 0xFFFF;
		battCellU[107] = 0xFFFF;
		break;
	case 0x181CFBF3:
		battCellU[108] = 0xFFFF;
		battCellU[109] = 0xFFFF;
		battCellU[110] = 0xFFFF;
		battCellU[111] = 0xFFFF;
		break;
	case 0x181DFBF3:
		battCellU[112] = 0xFFFF;
		battCellU[113] = 0xFFFF;
		battCellU[114] = 0xFFFF;
		battCellU[115] = 0xFFFF;
		break;
	case 0x181EFBF3:
		battCellU[116] = 0xFFFF;
		battCellU[117] = 0xFFFF;
		battCellU[118] = 0xFFFF;
		battCellU[119] = 0xFFFF;
		break;
	case 0x181FFBF3:
		battCellU[120] = 0xFFFF;
		battCellU[121] = 0xFFFF;
		battCellU[122] = 0xFFFF;
		battCellU[123] = 0xFFFF;
		break;
	case 0x1820FBF3:
		battCellU[124] = 0xFFFF;
		battCellU[125] = 0xFFFF;
		battCellU[126] = 0xFFFF;
		battCellU[127] = 0xFFFF;
		break;
	case 0x1821FBF3:
		battCellU[128] = 0xFFFF;
		battCellU[129] = 0xFFFF;
		battCellU[130] = 0xFFFF;
		battCellU[131] = 0xFFFF;
		break;
	case 0x1822FBF3:
		battCellU[132] = 0xFFFF;
		battCellU[133] = 0xFFFF;
		battCellU[134] = 0xFFFF;
		battCellU[135] = 0xFFFF;
		break;
	case 0x1823FBF3:
		battCellU[136] = 0xFFFF;
		battCellU[137] = 0xFFFF;
		battCellU[138] = 0xFFFF;
		battCellU[139] = 0xFFFF;
		break;
	case 0x1824FBF3:
		battCellU[140] = 0xFFFF;
		battCellU[141] = 0xFFFF;
		battCellU[142] = 0xFFFF;
		battCellU[143] = 0xFFFF;
		break;
	case 0x1825FBF3:
		battCellU[144] = 0xFFFF;
		battCellU[145] = 0xFFFF;
		battCellU[146] = 0xFFFF;
		battCellU[147] = 0xFFFF;
		break;
	case 0x1826FBF3:
		battCellU[148] = 0xFFFF;
		battCellU[149] = 0xFFFF;
		battCellU[150] = 0xFFFF;
		battCellU[151] = 0xFFFF;
		break;
	case 0x1827FBF3:
		battCellU[152] = 0xFFFF;
		battCellU[153] = 0xFFFF;
		battCellU[154] = 0xFFFF;
		battCellU[155] = 0xFFFF;
		break;
	case 0x1828FBF3:
		battCellU[156] = 0xFFFF;
		battCellU[157] = 0xFFFF;
		battCellU[158] = 0xFFFF;
		battCellU[159] = 0xFFFF;
		break;
	case 0x1829FBF3:
		battCellU[160] = 0xFFFF;
		battCellU[161] = 0xFFFF;
		battCellU[162] = 0xFFFF;
		battCellU[163] = 0xFFFF;
		break;
	case 0x182AFBF3:
		battCellU[164] = 0xFFFF;
		battCellU[165] = 0xFFFF;
		battCellU[166] = 0xFFFF;
		battCellU[167] = 0xFFFF;
		break;
	case 0x182BFBF3:
		battCellU[168] = 0xFFFF;
		battCellU[169] = 0xFFFF;
		battCellU[170] = 0xFFFF;
		battCellU[171] = 0xFFFF;
		break;
	case 0x182CFBF3:
		battCellU[172] = 0xFFFF;
		battCellU[173] = 0xFFFF;
		battCellU[174] = 0xFFFF;
		battCellU[175] = 0xFFFF;
		break;
	case 0x182DFBF3:
		battCellU[176] = 0xFFFF;
		battCellU[177] = 0xFFFF;
		battCellU[178] = 0xFFFF;
		battCellU[179] = 0xFFFF;
		break;
	case 0x182EFBF3:
		battCellU[180] = 0xFFFF;
		battCellU[181] = 0xFFFF;
		battCellU[182] = 0xFFFF;
		battCellU[183] = 0xFFFF;
		break;
	case 0x182FFBF3:
		battCellU[184] = 0xFFFF;
		battCellU[185] = 0xFFFF;
		battCellU[186] = 0xFFFF;
		battCellU[187] = 0xFFFF;
		break;
	case 0x1830FBF3:
		battCellU[188] = 0xFFFF;
		battCellU[189] = 0xFFFF;
		battCellU[190] = 0xFFFF;
		battCellU[191] = 0xFFFF;
		break;
	case 0x1831FBF3:
		battCellU[192] = 0xFFFF;
		battCellU[193] = 0xFFFF;
		battCellU[194] = 0xFFFF;
		battCellU[195] = 0xFFFF;
		break;
	case 0x1832FBF3:
		battCellU[196] = 0xFFFF;
		battCellU[197] = 0xFFFF;
		battCellU[198] = 0xFFFF;
		battCellU[199] = 0xFFFF;
		break;
	case 0x1833FBF3:
		battCellU[200] = 0xFFFF;
		battCellU[201] = 0xFFFF;
		battCellU[202] = 0xFFFF;
		battCellU[203] = 0xFFFF;
		break;
	case 0x1834FBF3:
		battCellU[204] = 0xFFFF;
		battCellU[205] = 0xFFFF;
		battCellU[206] = 0xFFFF;
		battCellU[207] = 0xFFFF;
		break;
	case 0x1835FBF3:
		battCellU[208] = 0xFFFF;
		battCellU[209] = 0xFFFF;
		battCellU[210] = 0xFFFF;
		battCellU[211] = 0xFFFF;
		break;
	case 0x1836FBF3:
		battCellU[212] = 0xFFFF;
		battCellU[213] = 0xFFFF;
		battCellU[214] = 0xFFFF;
		battCellU[215] = 0xFFFF;
		break;
	case 0x1837FBF3:
		battCellU[216] = 0xFFFF;
		battCellU[217] = 0xFFFF;
		battCellU[218] = 0xFFFF;
		battCellU[219] = 0xFFFF;
		break;
	case 0x1838FBF3:
		battCellU[220] = 0xFFFF;
		battCellU[221] = 0xFFFF;
		battCellU[222] = 0xFFFF;
		battCellU[223] = 0xFFFF;
		break;
	case 0x1839FBF3:
		battCellU[224] = 0xFFFF;
		battCellU[225] = 0xFFFF;
		battCellU[226] = 0xFFFF;
		battCellU[227] = 0xFFFF;
		break;
	case 0x183AFBF3:
		battCellU[228] = 0xFFFF;
		battCellU[229] = 0xFFFF;
		battCellU[230] = 0xFFFF;
		battCellU[231] = 0xFFFF;
		break;
	case 0x183BFBF3:
		battCellU[232] = 0xFFFF;
		battCellU[233] = 0xFFFF;
		battCellU[234] = 0xFFFF;
		battCellU[235] = 0xFFFF;
		break;
	case 0x183CFBF3:
		battCellU[236] = 0xFFFF;
		battCellU[237] = 0xFFFF;
		battCellU[238] = 0xFFFF;
		battCellU[239] = 0xFFFF;
		break;
	case 0x183DFBF3:
		battCellU[240] = 0xFFFF;
		battCellU[241] = 0xFFFF;
		battCellU[242] = 0xFFFF;
		battCellU[243] = 0xFFFF;
		break;
	case 0x183EFBF3:
		battCellU[244] = 0xFFFF;
		battCellU[245] = 0xFFFF;
		battCellU[246] = 0xFFFF;
		battCellU[247] = 0xFFFF;
		break;
	case 0x183FFBF3:
		battCellU[248] = 0xFFFF;
		battCellU[249] = 0xFFFF;
		battCellU[250] = 0xFFFF;
		battCellU[251] = 0xFFFF;
		break;
	case 0x1840FBF3:
		battCellU[252] = 0xFFFF;
		battCellU[253] = 0xFFFF;
		battCellU[254] = 0xFFFF;
		battCellU[255] = 0xFFFF;
		break;
	case 0x1841FBF3:
		battCellU[256] = 0xFFFF;
		battCellU[257] = 0xFFFF;
		battCellU[258] = 0xFFFF;
		battCellU[259] = 0xFFFF;
		break;
	case 0x1842FBF3:
		battCellU[260] = 0xFFFF;
		battCellU[261] = 0xFFFF;
		battCellU[262] = 0xFFFF;
		battCellU[263] = 0xFFFF;
		break;
	case 0x1843FBF3:
		battCellU[264] = 0xFFFF;
		battCellU[265] = 0xFFFF;
		battCellU[266] = 0xFFFF;
		battCellU[267] = 0xFFFF;
		break;
	case 0x1844FBF3:
		battCellU[268] = 0xFFFF;
		battCellU[269] = 0xFFFF;
		battCellU[270] = 0xFFFF;
		battCellU[271] = 0xFFFF;
		break;
	case 0x1845FBF3:
		battCellU[272] = 0xFFFF;
		battCellU[273] = 0xFFFF;
		battCellU[274] = 0xFFFF;
		battCellU[275] = 0xFFFF;
		break;
	case 0x1846FBF3:
		battCellU[276] = 0xFFFF;
		battCellU[277] = 0xFFFF;
		battCellU[278] = 0xFFFF;
		battCellU[279] = 0xFFFF;
		break;
	case 0x1847FBF3:
		battCellU[280] = 0xFFFF;
		battCellU[281] = 0xFFFF;
		battCellU[282] = 0xFFFF;
		battCellU[283] = 0xFFFF;
		break;
	case 0x1848FBF3:
		battCellU[284] = 0xFFFF;
		battCellU[285] = 0xFFFF;
		battCellU[286] = 0xFFFF;
		battCellU[287] = 0xFFFF;
		break;
	case 0x1849FBF3:
		battCellU[288] = 0xFFFF;
		battCellU[289] = 0xFFFF;
		battCellU[290] = 0xFFFF;
		battCellU[291] = 0xFFFF;
		break;
	case 0x184AFBF3:
		battCellU[292] = 0xFFFF;
		battCellU[293] = 0xFFFF;
		battCellU[294] = 0xFFFF;
		battCellU[295] = 0xFFFF;
		break;
	case 0x184BFBF3:
		battCellU[296] = 0xFFFF;
		battCellU[297] = 0xFFFF;
		battCellU[298] = 0xFFFF;
		battCellU[299] = 0xFFFF;
		break;
	case 0x184CFBF3:
		battCellU[300] = 0xFFFF;
		battCellU[301] = 0xFFFF;
		battCellU[302] = 0xFFFF;
		battCellU[303] = 0xFFFF;
		break;
	case 0x184DFBF3:
		battCellU[304] = 0xFFFF;
		battCellU[305] = 0xFFFF;
		battCellU[306] = 0xFFFF;
		battCellU[307] = 0xFFFF;
		break;
	case 0x184EFBF3:
		battCellU[308] = 0xFFFF;
		battCellU[309] = 0xFFFF;
		battCellU[310] = 0xFFFF;
		battCellU[311] = 0xFFFF;
		break;
	case 0x184FFBF3:
		battCellU[312] = 0xFFFF;
		battCellU[313] = 0xFFFF;
		battCellU[314] = 0xFFFF;
		battCellU[315] = 0xFFFF;
		break;
	case 0x1850FBF3:
		battCellU[316] = 0xFFFF;
		battCellU[317] = 0xFFFF;
		battCellU[318] = 0xFFFF;
		battCellU[319] = 0xFFFF;
		break;
	case 0x1851FBF3:
		battCellU[320] = 0xFFFF;
		battCellU[321] = 0xFFFF;
		battCellU[322] = 0xFFFF;
		battCellU[323] = 0xFFFF;
		break;
	case 0x1852FBF3:
		battCellU[324] = 0xFFFF;
		battCellU[325] = 0xFFFF;
		battCellU[326] = 0xFFFF;
		battCellU[327] = 0xFFFF;
		break;
	case 0x1853FBF3:
		battCellU[328] = 0xFFFF;
		battCellU[329] = 0xFFFF;
		battCellU[330] = 0xFFFF;
		battCellU[331] = 0xFFFF;
		break;
	case 0x1854FBF3:
		battCellU[332] = 0xFFFF;
		battCellU[333] = 0xFFFF;
		battCellU[334] = 0xFFFF;
		battCellU[335] = 0xFFFF;
		break;
	case 0x1855FBF3:
		battCellU[336] = 0xFFFF;
		battCellU[337] = 0xFFFF;
		battCellU[338] = 0xFFFF;
		battCellU[339] = 0xFFFF;
		break;
	case 0x1856FBF3:
		battCellU[340] = 0xFFFF;
		battCellU[341] = 0xFFFF;
		battCellU[342] = 0xFFFF;
		battCellU[343] = 0xFFFF;
		break;
	case 0x1857FBF3:
		battCellU[344] = 0xFFFF;
		battCellU[345] = 0xFFFF;
		battCellU[346] = 0xFFFF;
		battCellU[347] = 0xFFFF;
		break;
	case 0x1858FBF3:
		battCellU[348] = 0xFFFF;
		battCellU[349] = 0xFFFF;
		battCellU[350] = 0xFFFF;
		battCellU[351] = 0xFFFF;
		break;
	case 0x1859FBF3:
		battCellU[352] = 0xFFFF;
		battCellU[353] = 0xFFFF;
		battCellU[354] = 0xFFFF;
		battCellU[355] = 0xFFFF;
		break;
	case 0x185AFBF3:
		battCellU[356] = 0xFFFF;
		battCellU[357] = 0xFFFF;
		battCellU[358] = 0xFFFF;
		battCellU[359] = 0xFFFF;
		break;
	case 0x185BFBF3:
		battCellU[360] = 0xFFFF;
		battCellU[361] = 0xFFFF;
		battCellU[362] = 0xFFFF;
		battCellU[363] = 0xFFFF;
		break;
	case 0x185CFBF3:
		battCellU[364] = 0xFFFF;
		battCellU[365] = 0xFFFF;
		battCellU[366] = 0xFFFF;
		battCellU[367] = 0xFFFF;
		break;
	case 0x185DFBF3:
		battCellU[368] = 0xFFFF;
		battCellU[369] = 0xFFFF;
		battCellU[370] = 0xFFFF;
		battCellU[371] = 0xFFFF;
		break;
	case 0x185EFBF3:
		battCellU[372] = 0xFFFF;
		battCellU[373] = 0xFFFF;
		battCellU[374] = 0xFFFF;
		battCellU[375] = 0xFFFF;
		break;
	case 0x185FFBF3:
		battCellU[376] = 0xFFFF;
		battCellU[377] = 0xFFFF;
		battCellU[378] = 0xFFFF;
		battCellU[379] = 0xFFFF;
		break;
	case 0x1860FBF3:
		battCellU[380] = 0xFFFF;
		battCellU[381] = 0xFFFF;
		battCellU[382] = 0xFFFF;
		battCellU[383] = 0xFFFF;
		break;
	case 0x18A0FBF3:
		battCellTemp[0] = 0xFF;
		battCellTemp[1] = 0xFF;
		battCellTemp[2] = 0xFF;
		battCellTemp[3] = 0xFF;
		battCellTemp[4] = 0xFF;
		battCellTemp[5] = 0xFF;
		battCellTemp[6] = 0xFF;
		battCellTemp[7] = 0xFF;
		break;
	case 0x18A1FBF3:
		battCellTemp[8] = 0xFF;
		battCellTemp[9] = 0xFF;
		battCellTemp[10] = 0xFF;
		battCellTemp[11] = 0xFF;
		battCellTemp[12] = 0xFF;
		battCellTemp[13] = 0xFF;
		battCellTemp[14] = 0xFF;
		battCellTemp[15] = 0xFF;
		break;
	case 0x18A2FBF3:
		battCellTemp[16] = 0xFF;
		battCellTemp[17] = 0xFF;
		battCellTemp[18] = 0xFF;
		battCellTemp[19] = 0xFF;
		battCellTemp[20] = 0xFF;
		battCellTemp[21] = 0xFF;
		battCellTemp[22] = 0xFF;
		battCellTemp[23] = 0xFF;
		battCellTemp[24] = 0xFF;
		battCellTemp[25] = 0xFF;
		battCellTemp[26] = 0xFF;
		battCellTemp[27] = 0xFF;
		battCellTemp[28] = 0xFF;
		battCellTemp[29] = 0xFF;
		battCellTemp[30] = 0xFF;
		battCellTemp[31] = 0xFF;
		break;
	case 0x18A3FBF3:
		battCellTemp[32] = 0xFF;
		battCellTemp[33] = 0xFF;
		battCellTemp[34] = 0xFF;
		battCellTemp[35] = 0xFF;
		battCellTemp[36] = 0xFF;
		battCellTemp[37] = 0xFF;
		battCellTemp[38] = 0xFF;
		battCellTemp[39] = 0xFF;
		break;
	case 0x18A4FBF3:
		battCellTemp[40] = 0xFF;
		battCellTemp[41] = 0xFF;
		battCellTemp[42] = 0xFF;
		battCellTemp[43] = 0xFF;
		battCellTemp[44] = 0xFF;
		battCellTemp[45] = 0xFF;
		battCellTemp[46] = 0xFF;
		battCellTemp[47] = 0xFF;
		break;
	case 0x18A5FBF3:
		battCellTemp[48] = 0xFF;
		battCellTemp[49] = 0xFF;
		battCellTemp[50] = 0xFF;
		battCellTemp[51] = 0xFF;
		battCellTemp[52] = 0xFF;
		battCellTemp[53] = 0xFF;
		battCellTemp[54] = 0xFF;
		battCellTemp[55] = 0xFF;
		break;
	case 0x18A6FBF3:
		battCellTemp[56] = 0xFF;
		battCellTemp[57] = 0xFF;
		battCellTemp[58] = 0xFF;
		battCellTemp[59] = 0xFF;
		battCellTemp[60] = 0xFF;
		battCellTemp[61] = 0xFF;
		battCellTemp[62] = 0xFF;
		battCellTemp[63] = 0xFF;
		break;
	case 0x18FF08F3:
		mainPosRlyStatus = 0xFF;
		preRlyStatus = 0xFF;
		mainNegRlyStatus = 0xFF;
		thrRlyStatus = 0xFF;
		ptc1RlyStatus = 0xFF;
		airCondRlyStatus = 0xFF;
		dcChrg1PosRlyStatus = 0xFF;
		dcChrg1NegRlyStatus = 0xFF;
		dcChrg2PosRlyStatus = 0xFF;
		dcChrg2NegRlyStatus = 0xFF;
		heatPosRlyStatus = 0xFF;
		heatNegRlyStatus = 0xFF;
		coolRlyStatus = 0xFF;
		ptc2RlyStatus = 0xFF;
		mainPosRlyErrStatus = 0xFF;
		preRlyErrStatus = 0xFF;
		mainNegRlyErrStatus = 0xFF;
		thrRlyErrStatus = 0xFF;
		ptc1RlyErrStatus = 0xFF;
		airCondRlyErrStatus = 0xFF;
		dcChrg1PosRlyErrStatus = 0xFF;
		dcChrg1NegRlyErrStatus = 0xFF;
		dcChrg2PosRlyErrStatus = 0xFF;
		dcChrg2NegRlyErrStatus = 0xFF;
		heatPosRlyErrStatus = 0xFF;
		heatNegRlyErrStatus = 0xFF;
		coolRlyErrStatus = 0xFF;
		ptc2RlyErrStatus = 0xFF;
		break;
	case 0x18FF60F3:
		accChrgAh = 0xFFFFFFFF;
		accDischrgAh = 0xFFFFFFFF;
		break;
	case 0x18FF61F3:
		accChrgkWh = 0xFFFFFFFF;
		accDischrgkWh = 0xFFFFFFFF;
		break;
	case 0x18FF62F3:
		battSOH = 0xFF;
		break;
		/*		case	0x18FF63F3:
			SN[0] =0xFF;
			SN[1] =0xFF;
			SN[2] =0xFF;
			SN[3] =0xFF;
			SN[4] =0xFF;
			SN[5] =0xFF;
			SN[6] =0xFF;
			SN[7] =0xFF;
			break;
		case	0x18FF64F3:
			SN[8] =0xFF;
			SN[9] =0xFF;
			SN[10] =0xFF;
			SN[11] =0xFF;
			SN[12] =0xFF;
			SN[13] =0xFF;
			SN[14] =0xFF;
			SN[15] =0xFF;
			break;
		case	0x18FF65F3:
			SN[16] =0xFF;
			SN[17] =0xFF;
			SN[18] =0xFF;
			SN[19] =0xFF;
			SN[20] =0xFF;
			SN[21] =0xFF;
			SN[22] =0xFF;
			SN[23] =0xFF;
			break;
*/
	case 0x18FF66F3:
		accRecvryChrgAh = 0xFFFFFFFF;
		accRecvryChrgkWh = 0xFFFFFFFF;
		break;
	case 0x18FF67F3:
		accStationChrgAh = 0xFFFFFFFF;
		accStationChrgkWh = 0xFFFFFFFF;
		break;
	case 0x18FF68F3:
		accGunChrgAh = 0xFFFFFFFF;
		accGunChrgkWh = 0xFFFFFFFF;
		break;
	case 0x18FF69F3:
		sglChrgAh = 0xFFFFFFFF;
		sglChrgkWh = 0xFFFFFFFF;
		break;
	case 0x18FF10D0:
		bmsHVOn = 0xFF;
		break;
	case 0x18FF20EF:
		vcuDCVol = 0xFFFF;
		break;
	case 0x18FF14A3:
		acRelayStatus = 0xFF;
		ptcRelayStatus = 0xFF;
		mainRelayStatus = 0xFF;
		preRelayStatus = 0xFF;
		ptc2RelayStatus = 0xFF;
		acRelayErrorStatus = 0xFF;
		ptcRelayErrorStatus = 0xFF;
		mainRelayErrorStatus = 0xFF;
		preRelayErrorStatus = 0xFF;
		hvLockErrorStatus = 0xFF;
		ptc2RelayErrorStatus = 0xFF;
		break;
	case 0x18FF11F4:
		ebcStatus = 0xFF;
		ebcAskHVOn = 0xFF;
		ebcAskHVOff = 0xFF;
		retainLockSignal = 0xFF;
		dischargeLockSignal = 0xFF;
		chargeLockSignal = 0xFF;
		errorClass = 0xFF;
		errorCode1 = 0xFF;
		errorCode2 = 0xFF;
		chargeFlag = 0xFF;
		exchangeBattAirPressure = 0xFF;
		lifeSignal = 0xFF;
		break;
	case 0x18FF09D0:
		vehicleStatus = 0xFF;
		currentGearPosition = 0xFF;
		break;
	case 0x18FEF1D0:
		parkingBreakStatus = 0xFF;
		breakingStatus = 0xFF;
		break;
		/*		case	0x18FF55D0:
			for(UINT8 i = 0; i < sizeof(VIN); i++)
			{
				VIN[i] = 0xFF;
			}
			break;
*/
	case 0x18FEAE17:
		frontBreakingPressure = 0xFF;
		backBreakingPressure = 0xFF;
		frontBreakingPressureErrorStatus = 0xFF;
		backBreakingPressureErrorStatus = 0xFF;
		break;
	case 0x18FEC117:
		ODO = 0xFFFFFFFF;
		break;
	case 0x18FF15A0:
		dcdcErrorClass = 0xFF;
		dcdcWorkStatus = 0xFF;
		break;
	case 0x18FF16A1:
		mainElectricityErrorClass = 0xFF;
		pumpWorkStatus = 0xFF;
		break;
	case 0x18FF17A2:
		elecAirCompressorErrorStatus = 0xFF;
		elecAirCompressorWrokStatus = 0xFF;
		break;
	default:
		break;
	}
}

/***********************************************************************************************************************
 * SN号对比
 * 输入：CAN收到的SN号、已经存储的SN号
 * 输出：是否需要修改已经存储的SN号,true：需要修改  false：无需修改
 * 处理：--
***********************************************************************************************************************/
BOOL snCodeCompare(UINT8 *savedSN, UINT8 *receivedSN)
{
	BOOL ret = false;
	for (int i = 0; i < 12; i++)
	{
		//the sn number should be '0'-'9' or 'a'-'z' or 'A'-'Z'
		if ((receivedSN[i] >= '0' && receivedSN[i] <= '9') || (receivedSN[i] >= 'a' && receivedSN[i] <= 'z') || (receivedSN[i] >= 'A' && receivedSN[i] <= 'Z'))
		{
			if (savedSN[5 + i] == receivedSN[i]) //if they are same, we should not modify the savedSN
			{
				continue;
			}
			else
			{
				ret = true;
			}
		}
		else //if the code is invalid, we should not modify the savedSN
		{
			ret = false;
			return ret;
		}
	}
	return ret;
}
BOOL VINCodeCompare(UINT8 *saveVIN, UINT8 *receivedVIN)
{
	BOOL ret = false;
	for (int i = 0; i < 17; i++)
	{
		//the sn number should be '0'-'9' or 'a'-'z' or 'A'-'Z'
		if ((receivedVIN[i] >= '0' && receivedVIN[i] <= '9') || (receivedVIN[i] >= 'a' && receivedVIN[i] <= 'z') || (receivedVIN[i] >= 'A' && receivedVIN[i] <= 'Z'))
		{
			if (saveVIN[i] == receivedVIN[i]) //if they are same, we should not modify the savedSN
			{
				continue;
			}
			else
			{
				ret = true;
			}
		}
		else //if the code is invalid, we should not modify the savedSN
		{
			ret = false;
			return ret;
		}
	}
	return ret;
}

/***********************************************************************************************************************
 * UDS函数
 * 输入：报文内容（含ID）
 * 输出：--
 * 处理：根据报文内容，进行包括读取版本号、读写SN、查询状态，用于完成下线检测和通过CAN接收升级包等操作
***********************************************************************************************************************/
void UDS_Service(CAN_Msg_Type *CanRxMsg)
{
	UINT8 i, j = 0;
	UINT32 k = 0;
	INT8 ret, errorCount = 0;
	BOOL boolRet = false;
	static UINT8 snFlag = 0;
	static UINT32 sliceCounterFlag = 0;
	UINT32 tempSliceCounter = 0;
	static UINT8 counter = 0;
	CAN_Msg_Type UDSAnswer = {0};
	UINT32 posCode, negCode;
	UINT32 updateDifferDataByteLen = 0;
	static UINT8 updateDataBuffer[100];
	UINT8 nvmTemp[100];

	static UINT32 updateDifferDataSliceCounter = 0;
	static UINT8 UDSSwitch = 0;
	static UINT8 UDSDialogMode = 01;
	static UINT8 UDSBattSN[BATT_SN_LEN];

	for (i = 0; i < 2; i++)
	{
		UDSAnswer.DLC = 8;
		memset(UDSAnswer.Data, 0, UDSAnswer.DLC);
		UDSService[i] = CanRxMsg[i].Data[0];
		UDSSubService[i] = CanRxMsg[i].Data[1];
		UDSSubServiceActionCode[i] = CanRxMsg[i].Data[2];
		if (CanRxMsg[i].Id == 0x7A0)
		{
			switch (UDSService[i])
			{
			case 0x10:
				if (UDSSubService[i] == 0x01)
				{
					if ((UDSDialogMode == 0x01 || UDSDialogMode == 0x02) || UDSSwitch == 0)
					{
						UDSPositiveAnswer(0x04, i, 0x00);
						UDSSwitch = 0;
						UDSDialogMode = 1;
					}
					else
					{
						UDSNegtiveAnswer(0x05, i, 0xFF);
					}
				}
				else if (UDSSubService[i] == 0x02)
				{
					UDSPositiveAnswer(0x04, i, 0x00);
					UDSSwitch = 1;
					UDSDialogMode = 2;
				}
				else if (UDSSubService[i] == 0x03)
				{
					if (UDSSwitch == 1)
					{
						UDSPositiveAnswer(0x04, i, 0x00);
						UDSSwitch = 1;
						UDSDialogMode = 3;
					}
					else
					{
						UDSNegtiveAnswer(0x05, i, 0xFF);
					}
				}
				else if (UDSSubService[i] == 0x11) //make NB software reset
				{
					if (UDSDialogMode == 2)
					{
						UDSPositiveAnswer(0x04, i, 0x00);
						osDelay(100);
						SaveAppConfig();
						appSetCFUN(0);
						osDelay(1000);
						EC_SystemReset();
					}
					else
					{
						UDSNegtiveAnswer(0x05, i, 0xFF);
					}
				}
				else
				{
					UDSNegtiveAnswer(0x05, i, 0xEE);
				}
				break;
			case 0x22:
				if (UDSDialogMode == 2)
				{
					if (UDSSubService[i] == 0x01) //check the sw of NB
					{
						UDSPositiveAnswer(0x08, i, APPSWVERSION);
					}
					else if (UDSSubService[i] == 0x02) //check the hw of NB
					{
						UDSPositiveAnswer(0x06, i, HWVERSION);
					}
					else if (UDSSubService[i] == 0x03) //check the SN number
					{
						switch (UDSSubServiceActionCode[i])
						{
						case 00:
							UDSAnswer.Id = 0x7B0;
							CANEncodeFunction(UDSAnswer.Id, UDSAnswer.Data);
							ret = HAL_Can_Transmit(UDSAnswer);

							break;

						case 01:
							UDSAnswer.Id = 0x7B1;
							CANEncodeFunction(UDSAnswer.Id, UDSAnswer.Data);
							ret = HAL_Can_Transmit(UDSAnswer);
							break;

						case 02:
							UDSAnswer.Id = 0x7B2;
							CANEncodeFunction(UDSAnswer.Id, UDSAnswer.Data);
							ret = HAL_Can_Transmit(UDSAnswer);

							break;
						default:
							break;
						}
					}

					else if (UDSSubService[i] == 0x06) //check the tcp link of NB
					{
						UDSPositiveAnswer(0x06, i, TcpSendLen); //TcpconnectStatus
					}
					else if (UDSSubService[i] == 0x07) //check the GPS link of NB
					{
						posCode = (UINT32)GpsData[1];
						UDSPositiveAnswer(0x05, i, posCode); //gps satellite num(uint8), should be modified
					}
					else
					{
						UDSNegtiveAnswer(0x05, i, 0xEE);
					}
				}
				else //the service is not surpported in current dialog mode
				{
					UDSNegtiveAnswer(0x05, i, 0xFF);
				}
				break;
			case 0x2E: //write service
				if (UDSDialogMode == 2)
				{
					if (UDSSubService[i] == 0x0F) //write the update config:updateDifferDataByteLen
					{
						updateDifferDataByteLen = (CanRxMsg[i].Data[2] << 16) | (CanRxMsg[i].Data[3] << 8) | CanRxMsg[i].Data[4];
						UDSPositiveAnswer(0x04, i, 00);
					}
					else
					{
						UDSNegtiveAnswer(0x05, i, 0xEE);
					}
					break;
				}
				else
				{
					UDSNegtiveAnswer(0x05, i, 0xFF);
				}
				break;
			case 0x31: //clear the flash service
				if (UDSDialogMode == 3)
				{
					if (UDSSubService[i] == 0x0F) //clear the fota flash
					{
						if (UDSSubServiceActionCode[i] == 0x01)
						{
							//Clear the Flash
							boolRet = UDSClearFotaDownloadRegion();
							//if ok
							UDSPositiveAnswer(0x05, i, (UINT32)boolRet);
						}
						else
						{
							UDSNegtiveAnswer(0x06, i, UDSSubServiceActionCode[i] << 8 | 0xFF); //重点测试
						}
					}
					else
					{
						UDSNegtiveAnswer(0x05, i, 0xEE); //the subservice is not surpported
					}
				}
				else
				{
					UDSNegtiveAnswer(0x05, i, 0xFF); //the survie is not surpported in current dialog mode
				}
				break;
			case 0x34: //prepare for some one process
				if (UDSDialogMode == 3)
				{
					if (UDSSubService[i] == 0x0F) //ask for download update data
					{
						boolRet = UDSAskforDownLoadData();
						//if ok
						UDSPositiveAnswer(0x05, i, (UINT32)boolRet);
					}
					else
					{
						UDSNegtiveAnswer(0x05, i, 0xEE);
					}
				}
				else
				{
					UDSNegtiveAnswer(0x05, i, 0xFF);
				}
				break;
			case 0x36: //download the update data
				if (UDSDialogMode == 3)
				{
					if (downloadReady == TRUE)
					{
						counter++; //记录报文数量
						tempSliceCounter = (CanRxMsg[i].Data[1] << 16) | (CanRxMsg[i].Data[2] << 8) | (CanRxMsg[i].Data[3]);

						if (tempSliceCounter < (updateDifferDataPackageCounter + 1) * 25 && tempSliceCounter >= updateDifferDataPackageCounter * 25)
						{
							updateDifferDataSliceCounter = tempSliceCounter % 25;
#ifdef USING_PRINTF2
							printf("tempSliceCounter-updateDifferDataSliceCounter: %x-%x %02X %02X %02X %02X\n", tempSliceCounter, updateDifferDataSliceCounter, CanRxMsg[i].Data[4], CanRxMsg[i].Data[5], CanRxMsg[i].Data[6], CanRxMsg[i].Data[7]);
#endif

							for (j = 0; j < 4; j++)
							{
								updateDataBuffer[updateDifferDataSliceCounter * 4 + j] = CanRxMsg[i].Data[4 + j];
							}
#ifdef USING_PRINTF2
							printf("updateDataBuffer[updateDifferDataSliceCounter*4+j]:  %02X %02X %02X %02X\n", updateDataBuffer[updateDifferDataSliceCounter * 4 + 0], updateDataBuffer[updateDifferDataSliceCounter * 4 + 1], updateDataBuffer[updateDifferDataSliceCounter * 4 + 2], updateDataBuffer[updateDifferDataSliceCounter * 4 + 3]);
#endif
							if (updateDifferDataSliceCounter > 0)
							{
								sliceCounterFlag = sliceCounterFlag | (0x01 << updateDifferDataSliceCounter);
							}
							else
							{
								sliceCounterFlag = sliceCounterFlag | 0x01;
							}
							/*
							#ifdef USING_PRINTF
								printf("sliceCounterFlag = %x  counter=%d\n",sliceCounterFlag,counter);
							#endif
							*/
						}
						else
						{
							counter--;
						}

						if (counter == 25)
						{
							counter = 0;
							if (sliceCounterFlag == 0x1FFFFFF) //received all the 25 message of current package
							{
								//write the buffer(100 byte) to flash
#ifdef USING_PRINTF2
								for (int jjj = 0; jjj < 100; jjj++)
									printf("%02X ", updateDataBuffer[jjj]);
								printf("\n");
#endif
								ret = (uint8_t)BSP_QSPI_Write_Safe(updateDataBuffer, FLASH_FOTA_REGION_START + (updateDifferDataPackageCounter)*100, 100);
								errorCount = 0;
								while (ret != QSPI_OK && errorCount < 3) //try to write most 3 times
								{
									errorCount++;
									BSP_QSPI_Erase_Safe(FLASH_FOTA_REGION_START + (updateDifferDataPackageCounter)*100, 100);
									ret = (uint8_t)BSP_QSPI_Write_Safe(updateDataBuffer, FLASH_FOTA_REGION_START + (updateDifferDataPackageCounter)*100, 100);
								}
								memset(nvmTemp, 0, 100);
								BSP_QSPI_Read_Safe(nvmTemp, FLASH_FOTA_REGION_START + (updateDifferDataPackageCounter)*100, 100);
								//printf("addr =  %X\n",FLASH_FOTA_REGION_START+(updateDifferDataPackageCounter)*100);
								for (int ii = 0; ii < 100; ii++)
								{
									if (nvmTemp[ii] == updateDataBuffer[ii])
									{
#ifdef USING_PRINTF2
										printf("%02X ", nvmTemp[ii]);
#endif
										ret = QSPI_OK;
										continue;
									}
									else
									{
										ret = QSPI_ERROR;
										break;
									}
								}
								//printf("\n");
								if (ret == QSPI_OK) // write successed
								{
									UDSPositiveAnswer(0x08, i, tempSliceCounter);
									memset(updateDataBuffer, 0, 100);
									sliceCounterFlag = 0x0;
									updateDifferDataPackageCounter++;
								}
								else //write fail
								{
									UDSNegtiveAnswer(0x08, i, 0xFFFFFFFF); //failed to write this package to flash
								}
							}
							else
							{
								//received 25 messages, but lose one or more messages
								//in this case, updater will try to send the package again(most 4 times)
								UDSNegtiveAnswer(0x08, i, sliceCounterFlag);
							}
						}
					}
					else
					{
						UDSNegtiveAnswer(0x05, i, 0xEF); //the download process is not ready
						counter = 0;
					}
				}
				else
				{
					UDSNegtiveAnswer(0x05, i, 0xFF); //the service is not surpported in current dialog mode
				}
				break;
			case 0x37: //exit some one process
				if (UDSDialogMode == 3)
				{
					if (UDSSubService[i] == 0x0F) // exit the download
					{
						UDSPositiveAnswer(0x04, i, 0x00);
						downloadReady = FALSE;
					}
					else
					{
						UDSNegtiveAnswer(0x05, i, 0xEE);
					}
				}
				else
				{
					UDSNegtiveAnswer(0x05, i, 0xFF);
				}
				break;
			default:
				UDSNegtiveAnswer(0x04, i, 0xFF); //the service is not surpported
				break;
			}
		}
	}

	for (i = 0; i < 2; i++)
	{
		UDSService[i] = 0;
		UDSSubService[i] = 0;
	}
}

/***********************************************************************************************************************
 * UDS肯定响应
 * 输入：应答数据长度、应答的报文指数、响应代码
 * 输出：响应报文发送成功/失败
 * 处理：发送肯定响应报文
***********************************************************************************************************************/
UINT8 UDSPositiveAnswer(UINT8 answerLen, UINT8 messageIndex, UINT32 posCode)
{
	CAN_Msg_Type UDSAnswer;
	UINT8 ret;
	UDSAnswer.Id = 0x7A8;
	UDSAnswer.DLC = 8;
	UDSAnswer.Data[0] = answerLen;
	UDSAnswer.Data[1] = 0x78;
	UDSAnswer.Data[2] = UDSService[messageIndex];
	UDSAnswer.Data[3] = UDSSubService[messageIndex];
	if (answerLen == 4)
	{
		UDSAnswer.Data[4] = 0x00;
		UDSAnswer.Data[5] = 0x00;
		UDSAnswer.Data[6] = 0x00;
		UDSAnswer.Data[7] = 0x00;
	}
	else if (answerLen == 5)
	{
		UDSAnswer.Data[4] = posCode;
		UDSAnswer.Data[5] = 0x00;
		UDSAnswer.Data[6] = 0x00;
		UDSAnswer.Data[7] = 0x00;
	}
	else if (answerLen == 6)
	{
		UDSAnswer.Data[4] = posCode >> 8;
		UDSAnswer.Data[5] = posCode;
		UDSAnswer.Data[6] = 0x00;
		UDSAnswer.Data[7] = 0x00;
	}
	else if (answerLen == 7)
	{
		UDSAnswer.Data[4] = posCode >> 16;
		UDSAnswer.Data[5] = posCode >> 8;
		UDSAnswer.Data[6] = posCode;
		UDSAnswer.Data[7] = 0x00;
	}
	else if (answerLen == 8)
	{
		UDSAnswer.Data[4] = posCode >> 24;
		UDSAnswer.Data[5] = posCode >> 16;
		UDSAnswer.Data[6] = posCode >> 8;
		UDSAnswer.Data[7] = posCode;
	}
	ret = HAL_Can_Transmit(UDSAnswer);
	return ret;
}

/***********************************************************************************************************************
 * UDS否定响应
 * 输入：应答数据长度、应答的报文指数、响应代码
 * 输出：响应报文发送成功/失败
 * 处理：发送否定响应报文
***********************************************************************************************************************/
UINT8 UDSNegtiveAnswer(UINT8 answerLen, UINT8 messageIndex, UINT32 negCode)
{
	CAN_Msg_Type UDSAnswer;
	UINT8 ret;
	UDSAnswer.Id = 0x7A8;
	UDSAnswer.DLC = 8;
	UDSAnswer.Data[0] = answerLen;
	UDSAnswer.Data[1] = 0x7F;
	UDSAnswer.Data[2] = UDSService[messageIndex];
	UDSAnswer.Data[3] = UDSSubService[messageIndex];
	if (answerLen == 4)
	{
		UDSAnswer.Data[3] = negCode;
		UDSAnswer.Data[4] = 0x00;
		UDSAnswer.Data[5] = 0x00;
		UDSAnswer.Data[6] = 0x00;
		UDSAnswer.Data[7] = 0x00;
	}
	if (answerLen == 5)
	{
		UDSAnswer.Data[4] = negCode;
		UDSAnswer.Data[5] = 0x00;
		UDSAnswer.Data[6] = 0x00;
		UDSAnswer.Data[7] = 0x00;
	}
	else if (answerLen == 6)
	{
		UDSAnswer.Data[4] = negCode >> 8;
		UDSAnswer.Data[5] = negCode;
		UDSAnswer.Data[6] = 0x00;
		UDSAnswer.Data[7] = 0x00;
	}
	else if (answerLen == 7)
	{
		UDSAnswer.Data[4] = negCode >> 16;
		UDSAnswer.Data[5] = negCode >> 8;
		UDSAnswer.Data[6] = negCode;
		UDSAnswer.Data[7] = 0x00;
	}
	else if (answerLen == 8)
	{
		UDSAnswer.Data[4] = negCode >> 24;
		UDSAnswer.Data[5] = negCode >> 16;
		UDSAnswer.Data[6] = negCode >> 8;
		UDSAnswer.Data[7] = negCode;
	}
	ret = HAL_Can_Transmit(UDSAnswer);
	return ret;
}

/***********************************************************************************************************************
 * 在接收升级包前，做一些准备性工作
 * 输入：--
 * 输出：--
 * 处理：清空计数，并准备接收数据包
***********************************************************************************************************************/
BOOL UDSAskforDownLoadData()
{
	updateDifferDataPackageCounter = 0;
	downloadReady = true;
	return TRUE;
}

/***********************************************************************************************************************
 * 清除数据接收的flash区域
 * 输入：--
 * 输出：--
 * 处理：清除数据接收的flash区域
***********************************************************************************************************************/
BOOL UDSClearFotaDownloadRegion()
{
	UINT8 ret = FALSE;
	ret = BSP_QSPI_Erase_Safe(FLASH_FOTA_REGION_START, 0x46000); //512k-32k -200k = 280k -> 0x46000

	if (ret == QSPI_OK)
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

/***********************************************************************************************************************
 * 周期性报文组包
 * 输入：报文ID、can报文数据（指针）
 * 输出：--
 * 处理：根据不同的ID，进行组包，并放入指针中
***********************************************************************************************************************/

void CANEncodeFunction(UINT32 ID, UINT8 *msgData)
{
	memset(msgData, 0xFF, 8);
	switch (ID)
	{
	case 0x7B0:
		*(UINT8 *)(msgData + 0) = (AppNVMData.battSN[0]) & 0xFF;
		*(UINT8 *)(msgData + 1) = (AppNVMData.battSN[1]) & 0xFF;
		*(UINT8 *)(msgData + 2) = (AppNVMData.battSN[2]) & 0xFF;
		*(UINT8 *)(msgData + 3) = (AppNVMData.battSN[3]) & 0xFF;
		*(UINT8 *)(msgData + 4) = (AppNVMData.battSN[4]) & 0xFF;
		*(UINT8 *)(msgData + 5) = (AppNVMData.battSN[5]) & 0xFF;
		*(UINT8 *)(msgData + 6) = (AppNVMData.battSN[6]) & 0xFF;
		*(UINT8 *)(msgData + 7) = (AppNVMData.battSN[7]) & 0xFF;
		break;
	case 0x7B1:
		*(UINT8 *)(msgData + 0) = (AppNVMData.battSN[8]) & 0xFF;
		*(UINT8 *)(msgData + 1) = (AppNVMData.battSN[9]) & 0xFF;
		*(UINT8 *)(msgData + 2) = (AppNVMData.battSN[10]) & 0xFF;
		*(UINT8 *)(msgData + 3) = (AppNVMData.battSN[11]) & 0xFF;
		*(UINT8 *)(msgData + 4) = (AppNVMData.battSN[12]) & 0xFF;
		*(UINT8 *)(msgData + 5) = (AppNVMData.battSN[13]) & 0xFF;
		*(UINT8 *)(msgData + 6) = (AppNVMData.battSN[14]) & 0xFF;
		*(UINT8 *)(msgData + 7) = (AppNVMData.battSN[15]) & 0xFF;
		break;
	case 0x7B2:
		*(UINT8 *)(msgData + 0) = (AppNVMData.battSN[16]) & 0xFF;
		break;
	default:
		break;
	}
}

void TcpDataAssemble(UINT8 Tcptype, UINT8 *SendBuffer, UTC8TimeType UTC8TimeTcp)
{
	//msg 90 data
	switch (Tcptype)
	{
	case 0x90:
	{
		*(SendBuffer + 0) = TCP_START_SYM1;
		*(SendBuffer + 1) = TCP_START_SYM2;
		*(SendBuffer + 2) = TCP_CMD_SYM;
		*(SendBuffer + 3) = TCP_ANS_SYM;
		memcpy(SendBuffer + 4, AppNVMData.battSN, BATT_SN_LEN);
		*(SendBuffer + 0x15) = (TCP_ENCPT_DISABLE & 0xFF); //uint8	TCP_ENCPT_DISABLE
		UINT16 DataLen = 0x3D;
		*(SendBuffer + 0x16) = ((DataLen >> 8) & 0xFF); //uint16	DataLen
		*(SendBuffer + 0x17) = (DataLen & 0xFF);
		*(SendBuffer + 0x18) = (UTC8TimeTcp.year - 0x07D0 & 0xFF); //uint8	year
		*(SendBuffer + 0x19) = (UTC8TimeTcp.month & 0xFF);		   //uint8	month
		*(SendBuffer + 0x1A) = (UTC8TimeTcp.day & 0xFF);		   //uint8	day
		*(SendBuffer + 0x1B) = (UTC8TimeTcp.hour & 0xFF);		   //uint8	hour
		*(SendBuffer + 0x1C) = (UTC8TimeTcp.minute & 0xFF);		   //uint8	minute
		*(SendBuffer + 0x1D) = (UTC8TimeTcp.second & 0xFF);		   //uint8	second
		*(SendBuffer + 0x1E) = (Tcptype & 0xFF);				   //uint8	BATTMSG
		*(SendBuffer + 0x1F) = (UTC8TimeTcp.year - 0x07D0 & 0xFF); //uint8	year
		*(SendBuffer + 0x20) = (UTC8TimeTcp.month & 0xFF);		   //uint8	month
		*(SendBuffer + 0x21) = (UTC8TimeTcp.day & 0xFF);		   //uint8	day
		*(SendBuffer + 0x22) = (UTC8TimeTcp.hour & 0xFF);		   //uint8	hour
		*(SendBuffer + 0x23) = (UTC8TimeTcp.minute & 0xFF);		   //uint8	minute
		*(SendBuffer + 0x24) = (UTC8TimeTcp.second & 0xFF);		   //uint8	second
		memcpy(SendBuffer + 0x25, AppDataInfo.VIN, 17);
		*(SendBuffer + 0x36) = (vehicleStatus & 0xFF);		 //uint8	����״̬
		*(SendBuffer + 0x37) = (bmsHVOn & 0xFF);			 //uint8	BMS�ϸ�ѹָ��
		*(SendBuffer + 0x38) = (currentGearPosition & 0xFF); //uint8	��ǰ��λ
		*(SendBuffer + 0x39) = (parkingBreakStatus & 0xFF);	 //uint8	��ɲ�ź�
		*(SendBuffer + 0x3A) = (breakingStatus & 0xFF);		 //uint8	�ƶ�����
		*(SendBuffer + 0x3B) = ((ODO >> 24) & 0xFF);		 //uint32	�����
		*(SendBuffer + 0x3C) = ((ODO >> 16) & 0xFF);
		*(SendBuffer + 0x3D) = ((ODO >> 8) & 0xFF);
		*(SendBuffer + 0x3E) = (ODO & 0xFF);
		*(SendBuffer + 0x3F) = (dcdcWorkStatus & 0xFF);		   //uint8	DCDC״̬
		*(SendBuffer + 0x40) = (numOfChrgableSubsys & 0xFF);   //uint8	�ɳ����ϵͳ��
		*(SendBuffer + 0x41) = (chrgableSubsysCode & 0xFF);	   //uint8	�ɳ�索����ϵͳ��
		*(SendBuffer + 0x42) = (maxTempSubsysCode & 0xFF);	   //uint8	����¶���ϵͳ��
		*(SendBuffer + 0x43) = (maxTempCellCode & 0xFF);	   //uint8	����¶�̽�뵥�����
		*(SendBuffer + 0x44) = (minTempSubsysCode & 0xFF);	   //uint8	����¶���ϵͳ��
		*(SendBuffer + 0x45) = (minTempCellCode & 0xFF);	   //uint8	����¶�̽����ϵͳ����
		*(SendBuffer + 0x46) = (maxVolSubsysCode & 0xFF);	   //uint8	��ߵ�ѹ�����ϵͳ��
		*(SendBuffer + 0x47) = ((maxVolCellCode >> 8) & 0xFF); //uint16	��ߵ�ѹ��ص������
		*(SendBuffer + 0x48) = (maxVolCellCode & 0xFF);
		*(SendBuffer + 0x49) = (minVolSubsysCode & 0xFF);	   //uint8	��͵�ѹ�����ϵͳ��
		*(SendBuffer + 0x4A) = ((minVoCelllCode >> 8) & 0xFF); //uint16	��͵�ѹ��ص������
		*(SendBuffer + 0x4B) = (minVoCelllCode & 0xFF);
		*(SendBuffer + 0x4C) = (ebcStatus & 0xFF);			 //uint8	���������״̬
		*(SendBuffer + 0x4D) = (ebcAskHVOn & 0xFF);			 //uint8	��ֹ��ѹ�ϵ�
		*(SendBuffer + 0x4E) = (ebcAskHVOff & 0xFF);		 //uint8	�����ѹ�µ�
		*(SendBuffer + 0x4F) = (retainLockSignal & 0xFF);	 //uint8	����������ֹ�ź�
		*(SendBuffer + 0x50) = (dischargeLockSignal & 0xFF); //uint8	�ŵ绥���ź�
		*(SendBuffer + 0x51) = (chargeLockSignal & 0xFF);	 //uint8	��绥���ź�
		*(SendBuffer + 0x52) = (chargeFlag & 0xFF);			 //uint8	����־λ
		*(SendBuffer + 0x53) = ((vcuDCVol >> 8) & 0xFF);	 //uint16	���������ֱ��ĸ�ߵ�ѹ
		*(SendBuffer + 0x54) = (vcuDCVol & 0xFF);
		*(SendBuffer + 0x55) = bcc_chk(SendBuffer, 0x55);
		break;
	}
	case 0x91:
	{
		//msg 91 data
		*(SendBuffer + 0) = TCP_START_SYM1;
		*(SendBuffer + 1) = TCP_START_SYM2;
		*(SendBuffer + 2) = TCP_CMD_SYM;
		*(SendBuffer + 3) = TCP_ANS_SYM;
		memcpy(SendBuffer + 4, AppNVMData.battSN, BATT_SN_LEN);
		*(SendBuffer + 0x15) = (TCP_ENCPT_DISABLE & 0xFF); //uint8	TCP_ENCPT_DISABLE
		UINT16 DataLen = 0x3B + CELL_NUM * 2 + CELL_TEMP_NUM;
		*(SendBuffer + 0x16) = ((DataLen >> 8) & 0xFF); //uint16	DataLen
		*(SendBuffer + 0x17) = (DataLen & 0xFF);
		*(SendBuffer + 0x18) = (UTC8TimeTcp.year - 0x07D0 & 0xFF); //uint8	year
		*(SendBuffer + 0x19) = (UTC8TimeTcp.month & 0xFF);		   //uint8	month
		*(SendBuffer + 0x1A) = (UTC8TimeTcp.day & 0xFF);		   //uint8	day
		*(SendBuffer + 0x1B) = (UTC8TimeTcp.hour & 0xFF);		   //uint8	hour
		*(SendBuffer + 0x1C) = (UTC8TimeTcp.minute & 0xFF);		   //uint8	minute
		*(SendBuffer + 0x1D) = (UTC8TimeTcp.second & 0xFF);		   //uint8	second
		*(SendBuffer + 0x1E) = (Tcptype & 0xFF);				   //uint8	BATTMSG
		*(SendBuffer + 0x1F) = (UTC8TimeTcp.year - 0x07D0 & 0xFF); //uint8	year
		*(SendBuffer + 0x20) = (UTC8TimeTcp.month & 0xFF);		   //uint8	month
		*(SendBuffer + 0x21) = (UTC8TimeTcp.day & 0xFF);		   //uint8	day
		*(SendBuffer + 0x22) = (UTC8TimeTcp.hour & 0xFF);		   //uint8	hour
		*(SendBuffer + 0x23) = (UTC8TimeTcp.minute & 0xFF);		   //uint8	minute
		*(SendBuffer + 0x24) = (UTC8TimeTcp.second & 0xFF);		   //uint8	second
		*(SendBuffer + 0x25) = (csq & 0xFF);					   //uint8	csq
		*(SendBuffer + 0x26) = (bmsStatus & 0xFF);				   //uint8	BMS״̬
		*(SendBuffer + 0x27) = (chrgConctStatus & 0xFF);		   //uint8	�������״̬
		*(SendBuffer + 0x28) = (bmsErrClass & 0xFF);			   //uint8	BMS���ϵȼ�
		*(SendBuffer + 0x29) = (bmsErrNum & 0xFF);				   //uint8	BMS������
		*(SendBuffer + 0x2A) = (highVolPwrDwnReq & 0xFF);		   //uint8	�¸�ѹ����
		*(SendBuffer + 0x2B) = (chrgStatus & 0xFF);				   //uint8	���״̬
		*(SendBuffer + 0x2C) = (battSoc & 0xFF);				   //uint8	SOC
		*(SendBuffer + 0x2D) = (battSOH & 0xFF);				   //uint8	���SOH
		*(SendBuffer + 0x2E) = ((packTotalVol >> 8) & 0xFF);	   //uint16	����ܵ�ѹ
		*(SendBuffer + 0x2F) = (packTotalVol & 0xFF);
		*(SendBuffer + 0x30) = ((packTotalCurr >> 8) & 0xFF); //uint16	����ܵ���
		*(SendBuffer + 0x31) = (packTotalCurr & 0xFF);
		*(SendBuffer + 0x32) = ((insulationR >> 8) & 0xFF); //uint16	��Ե����
		*(SendBuffer + 0x33) = (insulationR & 0xFF);
#ifdef USING_PRINTF1
		printf("[%d]soh:\n", __LINE__);
		for (UINT8 i = 0; i < 8; i++)
		{
			printf("%02x ", *(SendBuffer + i + 0x2c));
		}
		printf("[%d]\n", __LINE__);
#endif
		*(SendBuffer + 0x34) = (mainPosRlyStatus & 0xFF);		//uint8	�����̵�������״̬
		*(SendBuffer + 0x35) = (preRlyStatus & 0xFF);			//uint8	Ԥ��̵�������״̬
		*(SendBuffer + 0x36) = (mainNegRlyStatus & 0xFF);		//uint8	�ܸ��̵�������״̬
		*(SendBuffer + 0x37) = (thrRlyStatus & 0xFF);			//uint8	����һ�̵�������״̬
		*(SendBuffer + 0x38) = (ptc1RlyStatus & 0xFF);			//uint8	PTC1�̵�������״̬
		*(SendBuffer + 0x39) = (airCondRlyStatus & 0xFF);		//uint8	�յ��̵�������״̬
		*(SendBuffer + 0x3A) = (dcChrg1PosRlyStatus & 0xFF);	//uint8	���1���̵�������״̬
		*(SendBuffer + 0x3B) = (dcChrg1NegRlyStatus & 0xFF);	//uint8	���1���̵�������״̬
		*(SendBuffer + 0x3C) = (dcChrg2PosRlyStatus & 0xFF);	//uint8	���2���̵�������״̬
		*(SendBuffer + 0x3D) = (dcChrg2NegRlyStatus & 0xFF);	//uint8	���2���̵�������״̬
		*(SendBuffer + 0x3E) = (heatPosRlyStatus & 0xFF);		//uint8	�������̵�������״̬
		*(SendBuffer + 0x3F) = (heatNegRlyStatus & 0xFF);		//uint8	���ȸ��̵�������״̬
		*(SendBuffer + 0x40) = (coolRlyStatus & 0xFF);			//uint8	ˮ��̵�������״̬
		*(SendBuffer + 0x41) = (ptc2RlyStatus & 0xFF);			//uint8	PTC2�̵�������״̬
		*(SendBuffer + 0x42) = (mainPosRlyErrStatus & 0xFF);	//uint8	�����̵�������״̬
		*(SendBuffer + 0x43) = (preRlyErrStatus & 0xFF);		//uint8	Ԥ��̵�������״̬
		*(SendBuffer + 0x44) = (mainNegRlyErrStatus & 0xFF);	//uint8	�ܸ��̵�������״̬
		*(SendBuffer + 0x45) = (thrRlyErrStatus & 0xFF);		//uint8	����һ�̵�������״̬
		*(SendBuffer + 0x46) = (ptc1RlyErrStatus & 0xFF);		//uint8	PTC1��������״̬
		*(SendBuffer + 0x47) = (airCondRlyErrStatus & 0xFF);	//uint8	�յ���������״̬
		*(SendBuffer + 0x48) = (dcChrg1PosRlyErrStatus & 0xFF); //uint8	���1����������״̬
		*(SendBuffer + 0x49) = (dcChrg1NegRlyErrStatus & 0xFF); //uint8	���1����������״̬
		*(SendBuffer + 0x4A) = (dcChrg2PosRlyErrStatus & 0xFF); //uint8	���2����������״̬
		*(SendBuffer + 0x4B) = (dcChrg2NegRlyErrStatus & 0xFF); //uint8	���2����������״̬
		*(SendBuffer + 0x4C) = (heatPosRlyErrStatus & 0xFF);	//uint8	��������������״̬
		*(SendBuffer + 0x4D) = (heatNegRlyErrStatus & 0xFF);	//uint8	���ȸ���������״̬
		*(SendBuffer + 0x4E) = (coolRlyErrStatus & 0xFF);		//uint8	ˮ���������״̬
		*(SendBuffer + 0x4F) = (ptc2RlyErrStatus & 0xFF);		//uint8	PTC2��������״̬
		*(SendBuffer + 0x50) = ((CELL_NUM >> 8) & 0xFF);		//uint16	����������
		*(SendBuffer + 0x51) = (CELL_NUM & 0xFF);
		for (UINT16 index = 0; index < CELL_NUM; index++)
		{
			*(SendBuffer + 0x52 + index * 2) = ((battCellU[index] >> 8) & 0xFF);
			*(SendBuffer + 0x52 + index * 2 + 1) = ((battCellU[index]) & 0xFF);
		}
		*(SendBuffer + 0x352) = (CELL_TEMP_NUM & 0xFF); //uint8	�ɳ�索���¶�̽�����
		memcpy(SendBuffer + 0x353, battCellTemp, CELL_TEMP_NUM);
		*(SendBuffer + 0x393) = bcc_chk(SendBuffer, 0x393);
		break;
	}
	case 0x92:
	{
		//msg 92 data
		*(SendBuffer + 0) = TCP_START_SYM1;
		*(SendBuffer + 1) = TCP_START_SYM2;
		*(SendBuffer + 2) = TCP_CMD_SYM;
		*(SendBuffer + 3) = TCP_ANS_SYM;
		memcpy(SendBuffer + 4, AppNVMData.battSN, BATT_SN_LEN);
		*(SendBuffer + 0x15) = (TCP_ENCPT_DISABLE & 0xFF); //uint8	TCP_ENCPT_DISABLE
		UINT16 DataLen = 0x35;
		*(SendBuffer + 0x16) = ((DataLen >> 8) & 0xFF); //uint16	DataLen
		*(SendBuffer + 0x17) = (DataLen & 0xFF);
		*(SendBuffer + 0x18) = (UTC8TimeTcp.year - 0x07D0 & 0xFF); //uint8	year
		*(SendBuffer + 0x19) = (UTC8TimeTcp.month & 0xFF);		   //uint8	month
		*(SendBuffer + 0x1A) = (UTC8TimeTcp.day & 0xFF);		   //uint8	day
		*(SendBuffer + 0x1B) = (UTC8TimeTcp.hour & 0xFF);		   //uint8	hour
		*(SendBuffer + 0x1C) = (UTC8TimeTcp.minute & 0xFF);		   //uint8	minute
		*(SendBuffer + 0x1D) = (UTC8TimeTcp.second & 0xFF);		   //uint8	second
		*(SendBuffer + 0x1E) = (Tcptype & 0xFF);				   //uint8	BATTMSG
		*(SendBuffer + 0x1F) = (UTC8TimeTcp.year - 0x07D0 & 0xFF); //uint8	year
		*(SendBuffer + 0x20) = (UTC8TimeTcp.month & 0xFF);		   //uint8	month
		*(SendBuffer + 0x21) = (UTC8TimeTcp.day & 0xFF);		   //uint8	day
		*(SendBuffer + 0x22) = (UTC8TimeTcp.hour & 0xFF);		   //uint8	hour
		*(SendBuffer + 0x23) = (UTC8TimeTcp.minute & 0xFF);		   //uint8	minute
		*(SendBuffer + 0x24) = (UTC8TimeTcp.second & 0xFF);		   //uint8	second
		*(SendBuffer + 0x25) = ((accChrgAh >> 24) & 0xFF);		   //uint32	�ۼƳ���Ah��
		*(SendBuffer + 0x26) = ((accChrgAh >> 16) & 0xFF);
		*(SendBuffer + 0x27) = ((accChrgAh >> 8) & 0xFF);
		*(SendBuffer + 0x28) = (accChrgAh & 0xFF);
		*(SendBuffer + 0x29) = ((accDischrgAh >> 24) & 0xFF); //uint32	�ۼƷų�Ah��
		*(SendBuffer + 0x2A) = ((accDischrgAh >> 16) & 0xFF);
		*(SendBuffer + 0x2B) = ((accDischrgAh >> 8) & 0xFF);
		*(SendBuffer + 0x2C) = (accDischrgAh & 0xFF);
		*(SendBuffer + 0x2D) = ((accChrgkWh >> 24) & 0xFF); //uint32	�ۼƳ���kWh��
		*(SendBuffer + 0x2E) = ((accChrgkWh >> 16) & 0xFF);
		*(SendBuffer + 0x2F) = ((accChrgkWh >> 8) & 0xFF);
		*(SendBuffer + 0x30) = (accChrgkWh & 0xFF);
		*(SendBuffer + 0x31) = ((accDischrgkWh >> 24) & 0xFF); //uint32	�ۼƷų�kWh��
		*(SendBuffer + 0x32) = ((accDischrgkWh >> 16) & 0xFF);
		*(SendBuffer + 0x33) = ((accDischrgkWh >> 8) & 0xFF);
		*(SendBuffer + 0x34) = (accDischrgkWh & 0xFF);
		*(SendBuffer + 0x35) = ((accRecvryChrgAh >> 24) & 0xFF); //uint32	�ۼƶ��ܻ�������Ah��
		*(SendBuffer + 0x36) = ((accRecvryChrgAh >> 16) & 0xFF);
		*(SendBuffer + 0x37) = ((accRecvryChrgAh >> 8) & 0xFF);
		*(SendBuffer + 0x38) = (accRecvryChrgAh & 0xFF);
		*(SendBuffer + 0x39) = ((accRecvryChrgkWh >> 24) & 0xFF); //uint32	�ۼƶ��ܻ�������kWh��
		*(SendBuffer + 0x3A) = ((accRecvryChrgkWh >> 16) & 0xFF);
		*(SendBuffer + 0x3B) = ((accRecvryChrgkWh >> 8) & 0xFF);
		*(SendBuffer + 0x3C) = (accRecvryChrgkWh & 0xFF);
		*(SendBuffer + 0x3D) = ((accStationChrgAh >> 24) & 0xFF); //uint32	�ۼƻ���վ����Ah��
		*(SendBuffer + 0x3E) = ((accStationChrgAh >> 16) & 0xFF);
		*(SendBuffer + 0x3F) = ((accStationChrgAh >> 8) & 0xFF);
		*(SendBuffer + 0x40) = (accStationChrgAh & 0xFF);
		*(SendBuffer + 0x41) = ((accStationChrgkWh >> 24) & 0xFF); //uint32	�ۼƻ���վ����kWh��
		*(SendBuffer + 0x42) = ((accStationChrgkWh >> 16) & 0xFF);
		*(SendBuffer + 0x43) = ((accStationChrgkWh >> 8) & 0xFF);
		*(SendBuffer + 0x44) = (accStationChrgkWh & 0xFF);
		*(SendBuffer + 0x45) = ((accGunChrgAh >> 24) & 0xFF); //uint32	�ۼƲ�ǹ������Ah��
		*(SendBuffer + 0x46) = ((accGunChrgAh >> 16) & 0xFF);
		*(SendBuffer + 0x47) = ((accGunChrgAh >> 8) & 0xFF);
		*(SendBuffer + 0x48) = (accGunChrgAh & 0xFF);
		*(SendBuffer + 0x49) = ((accGunChrgkWh >> 24) & 0xFF); //uint32	�ۼƲ�ǹ������kWh��
		*(SendBuffer + 0x4A) = ((accGunChrgkWh >> 16) & 0xFF);
		*(SendBuffer + 0x4B) = ((accGunChrgkWh >> 8) & 0xFF);
		*(SendBuffer + 0x4C) = (accGunChrgkWh & 0xFF);
		*(SendBuffer + 0x4D) = bcc_chk(SendBuffer, 0x4D);
		break;
	}
	}
	return;
}
